unit Main;

// Demonstration program to show the use of the 3D Studio library
//
// 03-OCT-99 ml: file drop, animation data
// 25-SEP-99 ml: animation data, user interface
// 12-SEP-99 ml: transparent materials, main texture path
// 05-SEP-99 ml: progress viewer, OpenGL viewer
// 22-AUG-99 ml: materials
// 11-AUG-99 ml: omni lights, cameras
// 10-AUG-99 ml: global settings, mesh properties
// 25-JUL-99 ml: first implementation
//
// (c) Copyright 1999, Dipl. Ing. Mike Lischke (public@lischke-online.de)

interface

uses
  Windows, Forms, Graphics,  File3DS, Classes, Controls, StdCtrls, ComCtrls, Dialogs,
  ExtCtrls, Menus, Types3DS, ImgList, ToolWin, CheckLst, Grids, Buttons, Messages;

type
  TMainForm = class(TForm)
    OPageControl: TPageControl;
    OGlobals: TTabSheet;
    MeshSheet: TTabSheet;
    OmniLightsSheet: TTabSheet;
    CameraSheet: TTabSheet;
    MaterialSheet: TTabSheet;
    DatabaseSheet: TTabSheet;
    StructureTree: TTreeView;
    KFPageControl: TPageControl;
    KFGlobals: TTabSheet;
    KFMeshSheet: TTabSheet;
    TabSheet3: TTabSheet;
    TabSheet4: TTabSheet;
    Label1: TLabel;
    Label2: TLabel;
    Open3DS: TOpenDialog;
    DumpGroup: TRadioGroup;
    Label3: TLabel;
    OGlobalsMemo: TRichEdit;
    KFGlobalsMemo: TRichEdit;
    MeshListBox: TListBox;
    Label4: TLabel;
    Label6: TLabel;
    OmniListBox: TListBox;
    Label7: TLabel;
    CameraListBox: TListBox;
    Label8: TLabel;
    MaterialListBox: TListBox;
    SpotLightSheet: TTabSheet;
    SpotListBox: TListBox;
    Label9: TLabel;
    StatusBar: TStatusBar;
    TabImages: TImageList;
    MeshPropBox: TCheckListBox;
    MeshMatrixGrid: TStringGrid;
    Label17: TLabel;
    MapInfoBox: TGroupBox;
    MapMatrixGrid: TStringGrid;
    Label18: TLabel;
    MapTypeLabel: TLabel;
    TilingLabel: TLabel;
    CenterLabel: TLabel;
    CylinderLabel: TLabel;
    IconSizeLabel: TLabel;
    ScaleLabel: TLabel;
    GroupBox2: TGroupBox;
    GroupBox3: TGroupBox;
    MatCountLabel: TLabel;
    FaceCountLabel: TLabel;
    TexCountLabel: TLabel;
    VFlagCountLabel: TLabel;
    VertCountLabel: TLabel;
    BoxNameLabel1: TLabel;
    BoxNameLabel2: TLabel;
    BoxNameLabel3: TLabel;
    BoxNameLabel6: TLabel;
    BoxNameLabel5: TLabel;
    BoxNameLabel4: TLabel;
    GroupBox4: TGroupBox;
    ProcDataLabel: TLabel;
    ProcNameLabel: TLabel;
    ProcSizeLabel: TLabel;
    UIColorLabel: TLabel;
    OmniPositionLabel: TLabel;
    OmniColorLabel: TLabel;
    OmniIntensityLabel: TLabel;
    OmniOnOffLabel: TLabel;
    Label5: TLabel;
    OmniExclusionBox: TListBox;
    GroupBox5: TGroupBox;
    OmniAttEnableLabel: TLabel;
    OmniAttInnerLabel: TLabel;
    OmniAttOuterLabel: TLabel;
    SpotPositionLabel: TLabel;
    SpotColorLabel: TLabel;
    SpotIntensityLabel: TLabel;
    SpotOnOffLabel: TLabel;
    Label23: TLabel;
    SpotExclusionBox: TListBox;
    GroupBox6: TGroupBox;
    SpotAttEnableLabel: TLabel;
    SpotAttInnerLabel: TLabel;
    SpotAttOuterLabel: TLabel;
    GroupBox7: TGroupBox;
    SpotTargetLabel: TLabel;
    SpotHotspotLabel: TLabel;
    SpotFalloffLabel: TLabel;
    SpotRollLabel: TLabel;
    SpotAspectLabel: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    SpotCastLabel: TLabel;
    SpotShadowStyleLabel: TLabel;
    SpotLocalLabel: TLabel;
    SpotFilterLabel: TLabel;
    SpotBiasLabel: TLabel;
    SpotRayBiasLabel: TLabel;
    SpotMapLabel: TLabel;
    SpotConeShowLabel: TLabel;
    SpotConeTypeLabel: TLabel;
    SpotOvershootLabel: TLabel;
    SpotBitmapLabel: TLabel;
    SpotProjectorUseLabel: TLabel;
    OmniColorShape: TShape;
    SpotColorShape: TShape;
    CameraPositionLabel: TLabel;
    CameraTargetLabel: TLabel;
    CameraRollLabel: TLabel;
    CameraFOVLabel: TLabel;
    CameraConeLabel: TLabel;
    CameraNearLabel: TLabel;
    CameraFarLabel: TLabel;
    MaterialPropBox: TCheckListBox;
    GroupBox1: TGroupBox;
    MatAmbientShape: TShape;
    MatDiffuseShape: TShape;
    MatSpecularShape: TShape;
    MatAmbientLabel: TLabel;
    MatDiffuseLabel: TLabel;
    MatSpecularLabel: TLabel;
    GroupBox8: TGroupBox;
    MatWireSizeLabel: TLabel;
    MatBlurLabel: TLabel;
    MatShinStrengthLabel: TLabel;
    MatShininessLabel: TLabel;
    MatShadingLabel: TLabel;
    MatSelfIllumLabel: TLabel;
    MatTransFallOffLabel: TLabel;
    MatTransparencyLabel: TLabel;
    GroupBox9: TGroupBox;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    SpeedButton6: TSpeedButton;
    SpeedButton7: TSpeedButton;
    SpeedButton8: TSpeedButton;
    Label11: TLabel;
    MeshMotionListBox: TListBox;
    Label12: TLabel;
    OmniMotionListBox: TListBox;
    SpotMotionSheet: TTabSheet;
    Label13: TLabel;
    SpotMotionListBox: TListBox;
    Label14: TLabel;
    CameraMotionListBox: TListBox;
    GroupBox10: TGroupBox;
    MParentLabel: TLabel;
    MFlags1Label: TLabel;
    MFlags2Label: TLabel;
    MPivotLabel: TLabel;
    MMinBoundLabel: TLabel;
    MMaxBoundLabel: TLabel;
    MMSAngleLabel: TLabel;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet5: TTabSheet;
    TabSheet6: TTabSheet;
    TabSheet7: TTabSheet;
    MPKCountLabel: TLabel;
    MPKFlagsLabel: TLabel;
    MPKListBox: TListBox;
    Label15: TLabel;
    MenuImages: TImageList;
    ToolBar1: TToolBar;
    LoadButton: TToolButton;
    CloseButton: TToolButton;
    ToolButton3: TToolButton;
    DefaultMapEdit: TComboBox;
    PickPathButton: TToolButton;
    ToolButton1: TToolButton;
    SpeedButton9: TSpeedButton;
    MRUFilePopup: TPopupMenu;
    MRKCountLabel: TLabel;
    MRKFlagsLabel: TLabel;
    Label22: TLabel;
    MRKListBox: TListBox;
    MSKCountLabel: TLabel;
    MSKFlagsLabel: TLabel;
    Label26: TLabel;
    MSKListBox: TListBox;
    MMKCountLabel: TLabel;
    MMKFlagsLabel: TLabel;
    Label29: TLabel;
    MMKListBox: TListBox;
    MHKCountLabel: TLabel;
    MHKFlagsLabel: TLabel;
    Label32: TLabel;
    MHKListBox: TListBox;
    GroupBox11: TGroupBox;
    OParentLabel: TLabel;
    OFlags1Label: TLabel;
    OFlags2Label: TLabel;
    GroupBox12: TGroupBox;
    SParentLabel: TLabel;
    SFlags1Label: TLabel;
    SFlags2Label: TLabel;
    PageControl3: TPageControl;
    TabSheet13: TTabSheet;
    SPKCountLabel: TLabel;
    SPKFlagsLabel: TLabel;
    Label56: TLabel;
    SPKListBox: TListBox;
    TabSheet14: TTabSheet;
    SHKCountLabel: TLabel;
    SHKFlagsLabel: TLabel;
    Label59: TLabel;
    SHKListBox: TListBox;
    TabSheet15: TTabSheet;
    SFKCountLabel: TLabel;
    SFKFlagsLabel: TLabel;
    Label62: TLabel;
    SFKListBox: TListBox;
    GroupBox13: TGroupBox;
    CParentLabel: TLabel;
    CFLags1Label: TLabel;
    CFLags2Label: TLabel;
    PageControl2: TPageControl;
    TabSheet8: TTabSheet;
    OPKCountLabel: TLabel;
    OPKFlagsLabel: TLabel;
    Label34: TLabel;
    OPKListBox: TListBox;
    TabSheet9: TTabSheet;
    OCKCountLabel: TLabel;
    OCKFlagsLabel: TLabel;
    Label37: TLabel;
    OCKListBox: TListBox;
    TabSheet10: TTabSheet;
    SCKCountLabel: TLabel;
    SCKFlagsLabel: TLabel;
    Label24: TLabel;
    SCKListBox: TListBox;
    TabSheet11: TTabSheet;
    TabSheet12: TTabSheet;
    SRKCountLabel: TLabel;
    SRKFlagsLabel: TLabel;
    Label25: TLabel;
    SRKListBox: TListBox;
    STKCountLabel: TLabel;
    STKFlagsLabel: TLabel;
    Label30: TLabel;
    STKListBox: TListBox;
    STKParentLabel: TLabel;
    PageControl4: TPageControl;
    TabSheet16: TTabSheet;
    CPKCountLabel: TLabel;
    CPKFlagsLabel: TLabel;
    Label27: TLabel;
    CPKListBox: TListBox;
    TabSheet19: TTabSheet;
    CFKCountLabel: TLabel;
    CFKFlagsLabel: TLabel;
    Label41: TLabel;
    CFKListBox: TListBox;
    TabSheet20: TTabSheet;
    CRKCountLabel: TLabel;
    CRKFlagsLabel: TLabel;
    Label44: TLabel;
    CRKListBox: TListBox;
    TabSheet21: TTabSheet;
    CTKCountLabel: TLabel;
    CTKFlagsLabel: TLabel;
    Label47: TLabel;
    CTKParentLabel: TLabel;
    CTKListBox: TListBox;
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure DumpGroupClick(Sender: TObject);
    procedure MeshListBoxClick(Sender: TObject);
    procedure OmniListBoxClick(Sender: TObject);
    procedure SpotListBoxClick(Sender: TObject);
    procedure CameraListBoxClick(Sender: TObject);
    procedure MaterialListBoxClick(Sender: TObject);
    procedure LoadButtonClick(Sender: TObject);
    procedure CloseButtonClick(Sender: TObject);
    procedure MapSettingsClick(Sender: TObject);
    procedure ToolButton4Click(Sender: TObject);
    procedure PickPathButtonClick(Sender: TObject);
    procedure MeshMotionListBoxClick(Sender: TObject);
    procedure OmniMotionListBoxClick(Sender: TObject);
    procedure SpotMotionListBoxClick(Sender: TObject);
    procedure CameraMotionListBoxClick(Sender: TObject);
    procedure MRUFilePopupPopup(Sender: TObject);
  private
    FReader : TFile3DS;
    FMRUFiles: TStringList;
    procedure AddInfo(Keyframer: Boolean; const Info: String; Indent: Cardinal = 1);
    procedure AddNewline(Keyframer: Boolean);
    procedure AddHeader(Keyframer: Boolean; const Info: String);
    procedure AddSubHeader(Keyframer: Boolean; const Info: String);
    function ConvertColor(const Color: TFColor3DS): String;
    procedure ShowAtmosphereSettings;
    procedure ShowBackgroundSettings;
    procedure ShowViewportSettings;
    function ConvertPoint(const Point: TPoint3DS): String; overload;
    function ConvertPoint(const X, Y, Z: Single): String; overload;
    procedure ShowAmbientAnimation;
    procedure ShowAnimationSettings;
    procedure ShowMeshSettings;
    procedure ClearAndGrayControls;
    function ConvertColor2(const Color: TFColor3DS): TColor;
    procedure MRUClick(Sender: TObject);
    procedure DoLoad(const FileName: String);
    function ConvertHeaderFlags1(Flags: Word): String;
    function ConvertHeaderFlags2(Flags: Word): String;
    function ConvertLoopControlFlags(Flags: Word): String;
    function ConvertKeyHeader(Header: TKeyHeader3DS): String;
    function ConvertRotation(const RotKey: TKFRotKey3DS): String;
    procedure WMDropFiles(var Msg: TWMDropFiles); message WM_DROPFILES;
  end;

var
  MainForm: TMainForm;

//---------------------------------------------------------------------------------------------------------------------

implementation

uses FileCtrl, Utils3DS,  Const3DS, SysUtils,  CommCtrl, BMForm, Viewer, Progress, IniFiles, ShellAPI;

{$R *.DFM}

const BooleanToCheckState : array[Boolean] of TCheckBoxState = (cbUnchecked, cbChecked);

//---------------------------------------------------------------------------------------------------------------------

procedure TMainForm.FormKeyPress(Sender: TObject; var Key: Char);

begin
  if Key = #27 then
  begin
    Key := #0;
    Close;
  end;
end;

//---------------------------------------------------------------------------------------------------------------------

procedure TMainForm.AddInfo(Keyframer: Boolean; const Info: String; Indent: Cardinal = 1);

var Edit: TRichEdit;

begin
  if KeyFramer then Edit := KFGlobalsMemo
               else Edit := OGlobalsMemo;
  with Edit do
  begin
    SelAttributes.Style := [];
    Lines.Add(StringOfChar(#9, Indent) + Info);
    UpdateWindow(Handle);
  end;
end;

//---------------------------------------------------------------------------------------------------------------------

procedure TMainForm.AddHeader(Keyframer: Boolean; const Info: String);

var Edit: TRichEdit;

begin
  if KeyFramer then Edit := KFGlobalsMemo
               else Edit := OGlobalsMemo;
  with Edit do
  begin
    SelAttributes.Style := [fsBold];
    Lines.Add(Info);
    UpdateWindow(Handle);
  end;
end;

//---------------------------------------------------------------------------------------------------------------------

procedure TMainForm.AddSubHeader(Keyframer: Boolean; const Info: String);

var Edit: TRichEdit;

begin
  if KeyFramer then Edit := KFGlobalsMemo
               else Edit := OGlobalsMemo;
  with Edit do
  begin
    SelAttributes.Style := [fsItalic];
    Lines.Add(#9 + Info);
    UpdateWindow(Handle);
  end;
end;

//---------------------------------------------------------------------------------------------------------------------

procedure TMainForm.AddNewline(Keyframer: Boolean);

var Edit: TRichEdit;

begin
  if KeyFramer then Edit := KFGlobalsMemo
               else Edit := OGlobalsMemo;
  with Edit do
  begin
    Lines.Add('');
    UpdateWindow(Handle);
  end;
end;

//---------------------------------------------------------------------------------------------------------------------

function TMainForm.ConvertColor(const Color: TFColor3DS): String;

begin
  Result := Format('red: %d; green: %d; blue: %d', [Round(Color.R * 255), Round(Color.G * 255), Round(Color.B * 255)]);
end;

//---------------------------------------------------------------------------------------------------------------------

function TMainForm.ConvertPoint(const Point: TPoint3DS): String;

begin
  Result := Format('x: %.3g; y: %.3g; z: %.3g', [Point.X, Point.Y, Point.Z]);
end;

//---------------------------------------------------------------------------------------------------------------------

function TMainForm.ConvertPoint(const X, Y, Z: Single): String;

begin
  Result := Format('x: %.3g; y: %.3g; z: %.3g', [X, Y, Z]);
end;

//---------------------------------------------------------------------------------------------------------------------

function TMainForm.ConvertColor2(const Color: TFColor3DS): TColor;

begin
  Result := RGB(Round(Color.R * 255), Round(Color.G * 255), Round(Color.B * 255));
end;

//---------------------------------------------------------------------------------------------------------------------

function TMainForm.ConvertRotation(const RotKey: TKFRotKey3DS): String;

begin
  with RotKey do
    Result := Format('angle: %.3g;  axis: ', [Angle]) + ConvertPoint(X, Y, Z);
end;

//---------------------------------------------------------------------------------------------------------------------

procedure TMainForm.ShowAtmosphereSettings;

const AtmoTypeToString: array[TAtmosphereType3DS] of String = ('no atmosphere', 'use fog', 'use layer fog', 'use distance cue');
      FallOffToString: array[TLayerFogFalloff3DS] of String = ('no fall off', 'fall off to the top', 'fall off to the bottom');

begin
  with FReader do
  try
    AddHeader(False, 'Atmosphere settings:');
    with Atmosphere do
    begin
      AddSubHeader(False, 'Active atmosphere:');
      AddInfo(False, AtmoTypeToString[ActiveAtmo], 2);
      case ActiveAtmo of
        atUseFog:
          begin
            AddSubHeader(False, 'Fog settings:');
            AddInfo(False, Format('near plane: %.3g; near density: %.3g', [Fog.NearPlane, Fog.NearDensity]), 2);
            AddInfo(False, Format('far plane: %.3g; far density: %.3g', [Fog.FarPlane, Fog.FarDensity]), 2);
            if Fog.FogBgnd then AddInfo(False, Format('fog color: %s; affect background', [ConvertColor(Fog.FogColor)]), 2)
                           else AddInfo(False, Format('fog color: %s; don''t affect background', [ConvertColor(Fog.FogColor)]), 2);
          end;
        atUseLayerFog:
          begin
            AddSubHeader(False, 'Layer fog settings:');
            AddInfo(False, Format('lower bound: %.3g; upper bound: %.3g', [LayerFog.ZMin, LayerFog.ZMax]), 2);
            AddInfo(False, Format('density: %.3g; color: %s', [LayerFog.Density, ConvertColor(LayerFog.FogColor)]), 2);
            if LayerFog.FogBgnd then AddInfo(False, Format('fall off: %s; affect background', [FallOffToString[LayerFog.FallOff]]), 2)
                                else AddInfo(False, Format('fall off: %s; don''t affect background', [FallOffToString[LayerFog.FallOff]]), 2);
          end;
        atUseDistanceCue:
          begin
            AddSubHeader(False, 'Distance cue settings:');
            AddInfo(False, Format('near plane: %.3g; near dimming: %.3g', [DCue.NearPlane, DCue.NearDim]), 2);
            AddInfo(False, Format('far plane: %.3g; far dimming: %.3g', [DCue.FarPlane, DCue.FarDim]), 2);
            if DCue.DCueBgnd then AddInfo(False, 'affect background', 2)
                             else AddInfo(False, 'don''t affect background', 2);
          end;
      end;
    end;
    AddNewline(False);
  except
    MessageDlg('Error while reading atmosphere settings', mtError, [mbOk], 0);
  end
end;

//---------------------------------------------------------------------------------------------------------------------

procedure TMainForm.ShowBackgroundSettings;

const BackgroundToString: array[TBackgroundType3DS] of String = ('no background used', 'solid background', 'vertical gradient', 'background bitmap');

begin
  with FReader do
  try
    AddHeader(False, 'Background settings:');
    with Background do
    begin
      AddSubHeader(False, 'Background type:');
      AddInfo(False, BackgroundToString[BgndUsed], 2);
      case BgndUsed of
        btUseSolidBgnd:
          begin
            AddSubHeader(False, 'Solid background settings:');
            AddInfo(False, Format('color: %s', [ConvertColor(Solid)]), 2);
          end;
        btUseVGradientBgnd:
          begin
            AddSubHeader(False, 'Vertical gradient settings:');
            AddInfo(False, Format('mid color band placement: %d%%', [Round(VGradient.GradPercent * 100)]), 2);
            AddInfo(False, Format('top band color: %s', [ConvertColor(VGradient.Top)]), 2);
            AddInfo(False, Format('mid band color: %s', [ConvertColor(VGradient.Mid)]), 2);
            AddInfo(False, Format('bottom band color: %s', [ConvertColor(VGradient.Bottom)]), 2);
          end;
        btUseBitmapBgnd:
          begin
            AddSubHeader(False, 'Bitmap settings:');
            AddInfo(False, Format('bitmap name: %s', [Bitmap]), 2);
          end;
      end;
    end;
    AddNewline(False);
  except
    MessageDlg('Error while reading background settings', mtError, [mbOk], 0);
  end;
end;

//---------------------------------------------------------------------------------------------------------------------

procedure TMainForm.ShowMeshSettings;

begin
  with FReader do
  try
    AddHeader(False, 'Mesh settings:');
    with MeshSettings do
    begin
      AddInfo(False, Format('master scale: %.3g', [MasterScale]), 2);
      AddInfo(False, Format('ambient light color: %s', [ConvertColor(AmbientLight)]), 2);
      AddInfo(False, Format('default object construction axis: %s', [ConvertPoint(OConsts)]), 2);
      AddSubHeader(False, 'Shadow settings:');
      case Shadow.AType of
        ssUseShadowMap:
          begin
            AddInfo(False, 'use shadow map', 2);
            AddInfo(False, Format('bias: %.3g', [Shadow.Bias]), 2);
            AddInfo(False, Format('map size: %d', [Shadow.MapSize]), 2);
          end;
        ssUseRayTraceShadow:
          begin
            AddInfo(False, 'use raytrace shadow', 2);
            AddInfo(False, Format('bias: %.3g; ray bias: %.3g', [Shadow.Bias, Shadow.RayBias]), 2);
          end;
      end;
      AddInfo(False, Format('filter: %.3g', [Shadow.Filter]), 2);
    end;
    AddNewline(False);
  except
    MessageDlg('Error while mesh settings', mtError, [mbOk], 0);
  end;
end;

//---------------------------------------------------------------------------------------------------------------------

procedure TMainForm.ShowViewportSettings;

const VPTypeToString: array[TViewType3DS] of String = ('no viewport defined', 'top view', 'bottom view',
                                                       'left view', 'right view', 'front view', 'back view',
                                                       'user view', 'camera view', 'spotlight view');

begin
  with FReader do
  try
    AddHeader(False, 'Viewport settings:');
    with Viewport do
    begin
      AddSubHeader(False, 'Viewport type:');
      AddInfo(False, VPTypeToString[AType], 2);
      AddSubHeader(False, 'Viewport size:');
      with Size do
        AddInfo(False, Format('left: %d; top: %d; width: %d; height: %d', [XPos, YPos, Width, height]), 2);
      case AType of
        vtTopView3DS,
        vtBottomView3DS,
        vtLeftView3DS,
        vtRightView3DS,
        vtFrontView3DS,
        vtBackView3DS:
          begin
            AddSubHeader(False, 'Orthogonal view:');
            AddInfo(False, Format('center: %s', [ConvertPoint(Ortho.Center)]), 2);
            AddInfo(False, Format('zoom: %.3g', [Ortho.Zoom]), 2);
          end;
        vtUserView3DS:
          begin
            AddSubHeader(False, 'User defined view:');
            AddInfo(False, Format('center: %s', [ConvertPoint(User.Center)]), 2);
            AddInfo(False, Format('zoom: %.3g', [User.Zoom]), 2);
            AddInfo(False, Format('horizontal angle: %.3g; vertical angle: %.3g', [User.HorAng, User.VerAng]), 2);
          end;
        vtCameraView3DS:
          begin
            AddSubHeader(False, 'Camera view:');
            AddInfo(False, Format('camera name: %s', [Camera]), 2);
          end;
      end;
    end;
    AddNewline(False);
  except
    MessageDlg('Error while reading viewport settings', mtError, [mbOk], 0);
  end;
end;

//---------------------------------------------------------------------------------------------------------------------

procedure TMainForm.ShowAmbientAnimation;

var I: Integer;
    Info: String;

begin
  with FReader do
  try
    AddHeader(True, 'Ambient light motion:');
    with Keyframer.AmbientLightMotion^ do
    begin
      AddSubHeader(True, 'Flags:');
      AddInfo(True, Format('flags 1: $%x; flags 2: $%x', [Flags1, Flags2]), 2);
      if (Flags1 and NODE_RENDOB_HIDE) <> 0 then AddInfo(True, 'node renderob. hide', 3);
      if (Flags1 and NODE_OFF) <> 0 then AddInfo(True, 'node off', 3);
      if (Flags1 and ATKEYFLAGS) <> 0 then
      begin
        AddInfo(True, 'ATKEYs set', 3);
        if (Flags1 and ATKEY1) <> 0 then AddInfo(True, 'ATKEY 1', 4);
        if (Flags1 and ATKEY2) <> 0 then AddInfo(True, 'ATKEY 2', 4);
        if (Flags1 and ATKEY3) <> 0 then AddInfo(True, 'ATKEY 3', 4);
        if (Flags1 and ATKEY4) <> 0 then AddInfo(True, 'ATKEY 4', 4);
        if (Flags1 and ATKEY5) <> 0 then AddInfo(True, 'ATKEY 5', 4);
      end;
      if (Flags1 and MARK_NODE) <> 0 then AddInfo(True, 'mark node', 3);
      if (Flags1 and DISABLE_NODE) <> 0 then AddInfo(True, 'disable node', 3);
      if (Flags1 and HIDE_NODE) <> 0 then AddInfo(True, 'hide node', 3);
      if (Flags1 and FAST_NODE) <> 0 then AddInfo(True, 'fast node', 3);
      if (Flags1 and PRIMARY_NODE) <> 0 then AddInfo(True, 'primary node', 3);
      if (Flags1 and NODE_CALC_PATH) <> 0 then AddInfo(True, 'node calculate path', 3);

      // color keys
      {$ifopt R+} {$R-} {$define RangeCheck} {$endif}
      AddSubHeader(True, 'Color keys:');
      if NCKeys = 0 then AddInfo(True, 'no color keys defined', 2)
                    else
      begin
        AddInfo(True, Format('%d color key(s); flags: $%x', [NCKeys, NCFlag]), 2);
        AddInfo(True, 'key settings', 2);
        for I := 0 to NCKeys - 1 do
        begin
          with CKeys[I] do
          begin
            Info := Format('frame postition: %d', [Time]);
            if (RFlags and $01) <> 0 then Info := Info + Format('; tension: %.3g', [Tension]);
            if (RFlags and $02) <> 0 then Info := Info + Format('; continuity: %.3g', [Continuity]);
            if (RFlags and $04) <> 0 then Info := Info + Format('; bias: %.3g', [Bias]);
            if (RFlags and $08) <> 0 then Info := Info + Format('; ease to: %.3g', [EaseTo]);
            if (RFlags and $10) <> 0 then Info := Info + Format('; ease from: %.3g', [EaseFrom]);
          end;
          Info := Info + '; ' + ConvertColor(Color[I]);
          AddInfo(True, Info, 3);
        end;
      end;
      {$ifdef RangeCheck} {$undef RangeCheck} {$R+} {$endif}
    end;
    AddNewline(True);
  except
    MessageDlg('Error while reading ambient animation settings', mtError, [mbOk], 0);
  end;
end;

//---------------------------------------------------------------------------------------------------------------------

procedure TMainForm.ShowAnimationSettings;

begin
  with FReader do
  try
    AddHeader(True, 'Global settings:');
    with Keyframer.Settings do
    begin
      AddSubHeader(True, 'Frames:');
      AddInfo(True, Format('frame count: %d; current frame: %d', [Anim.Length, Anim.CurFrame]), 2);
      AddSubHeader(True, 'Segments:');
      if Seg.Use then AddInfo(True, Format('begin: %d; end: %d', [Seg.SegBegin, Seg.SegEnd]), 2)
                 else AddInfo(True, 'not used', 2);
    end;
    AddNewline(True);
  except
    MessageDlg('Error while reading animation settings', mtError, [mbOk], 0);
  end;
end;

//---------------------------------------------------------------------------------------------------------------------

procedure TMainForm.FormCreate(Sender: TObject);

var IniFile: TIniFile;
    I: Integer;

begin
  ClearAndGrayControls;
  FReader := TFile3DS.Create;
  OPageControl.ActivePage := OGlobals;
  KFPageControl.ActivePage := KFGlobals;

  FMRUFiles := TStringList.Create;
  // read most recently used files and pathes from an ini file
  IniFile := TIniFile.Create(ExtractFilePath(Application.ExeName) + 'MRU.ini');
  try
    IniFile.ReadSectionValues('Files', FMRUFiles);
    while FMRUFiles.Count > 20 do FMRUFiles.Delete(20);
    for I := 0 to FMRUFiles.Count - 1 do
      FMRUFiles[I] := FMRUFiles.Values['File' + IntToStr(I)];

    IniFile.ReadSectionValues('Pathes', DefaultMapEdit.Items);
    while DefaultMapEdit.Items.Count > 20 do DefaultMapEdit.Items.Delete(20);
    for I := 0 to DefaultMapEdit.Items.Count - 1 do
      DefaultMapEdit.Items[I] := DefaultMapEdit.Items.Values['Path' + IntToStr(I)];
  finally
    IniFile.Free;
  end;
  
  DragAcceptFiles(Handle, True);
end;

//---------------------------------------------------------------------------------------------------------------------

procedure TMainForm.FormDestroy(Sender: TObject);

var IniFile: TIniFile;
    I: Integer;

begin
  IniFile := TIniFile.Create(ExtractFilePath(Application.ExeName) + 'MRU.ini');
  try
    IniFile.EraseSection('Files');
    for I := 0 to FMRUFiles.Count - 1 do
      IniFile.WriteString('Files', 'File' + IntToStr(I), FMRUFiles[I]);
    IniFile.EraseSection('Pathes');
    for I := 0 to DefaultMapEdit.Items.Count - 1 do
      IniFile.WriteString('Pathes', 'Path' + IntToStr(I), DefaultMapEdit.Items[I]);
  finally
    IniFile.Free;
  end;
  FMRUFiles.Free;
  FReader.Free;
  StructureTree.FullCollapse;
end;

//---------------------------------------------------------------------------------------------------------------------

procedure TMainForm.DumpGroupClick(Sender: TObject);

const IndexToDumpLevel: array [0..2] of TDumpLevel = (dlTerseDump,  dlMediumDump,  dlMaximumDump);

var Liste: TStringList;
    Stream: TMemoryStream;
    Node: TTreeNode;

begin
  // dump db structure to structure tree
  Liste := TStringList.Create;
  Stream := TMemoryStream.Create;
  Screen.Cursor := crHourGlass;
  try
    StructureTree.FullCollapse;
    FReader.DumpDatabase(Liste, IndexToDumpLevel[DumpGroup.ItemIndex]);
    Liste.SaveToStream(Stream);
    Stream.Position := 0;
    StructureTree.LoadFromStream(Stream);
    if StructureTree.Items.Count > 0 then
    begin
      StructureTree.Items.BeginUpdate;
      Node := StructureTree.Items.GetFirstNode;
      Node.Expand(False);
      Node := Node.GetFirstChild;
      while assigned(Node) do
      begin
        Node.Expand(False);
        Node := Node.GetNextSibling;
      end;
      StructureTree.Items.GetFirstNode.MakeVisible;
      StructureTree.Items.EndUpdate;
    end;
  finally
    Stream.Free;
    Liste.Free;
    Screen.Cursor := crDefault;
  end;
end;

//---------------------------------------------------------------------------------------------------------------------

procedure TMainForm.MeshListBoxClick(Sender: TObject);

var I, J: Integer;

begin
  with FReader.Objects.Mesh[MeshListBox.ItemIndex]^, MeshPropBox do
  begin
    State[0] := BooleanToCheckState[not IsHidden];
    State[1] := BooleanToCheckState[IsvisLofter];
    State[2] := BooleanToCheckState[IsMatte];
    State[3] := BooleanToCheckState[not IsNoCast];
    State[4] := BooleanToCheckState[IsFast];
    State[5] := BooleanToCheckState[not IsNorcvShad];
    State[6] := BooleanToCheckState[IsFrozen];

    VertCountLabel.Caption := Format('%d vertices', [NVertices]);
    VertCountLabel.Enabled := True;
    VFlagCountLabel.Caption := Format('%d vertex flags', [NVFlags]);
    VFlagCountLabel.Enabled := True;
    TexCountLabel.Caption := Format('%d texture coords.', [NTextVerts]);
    TexCountLabel.Enabled := True;
    FaceCountLabel.Caption := Format('%d faces', [NFaces]);
    FaceCountLabel.Enabled := True;
    MatCountLabel.Caption := Format('%d used materials', [NMats]);
    MatCountLabel.Enabled := True;
    if UseMapInfo then
    begin
      MapTypeLabel.Caption := Format('map type: %x', [Map.MapType]);
      TilingLabel.Caption := Format('tiling %.3g x %.3g', [Map.TileX, Map.TileY]);
      CenterLabel.Caption := 'center: ' + ConvertPoint(Map.CenX, Map.CenY, Map.CenZ);
      CylinderLabel.Caption := Format('cylinder icon height: %.3g', [Map.CH]);
      IconSizeLabel.Caption := Format('planar icon size: %.3g x %.3g', [Map.PW, Map.PH]);
      ScaleLabel.Caption := Format('scale factor: %.3g', [Map.Scale]);
    end
    else
    begin
      MapTypeLabel.Caption := 'not used.';
      TilingLabel.Caption := 'tiling: ?';
      CenterLabel.Caption := 'center: ?';
      CylinderLabel.Caption := 'cylinder icon height: ?';
      IconSizeLabel.Caption := 'planar icon size: ?';
      ScaleLabel.Caption := 'scale factor: ?';
    end;
    if UseBoxMap then
    begin
      BoxNameLabel1.Caption := BoxMap[0];
      BoxNameLabel2.Caption := BoxMap[1];
      BoxNameLabel3.Caption := BoxMap[2];
      BoxNameLabel6.Caption := BoxMap[3];
      BoxNameLabel5.Caption := BoxMap[4];
      BoxNameLabel4.Caption := BoxMap[5];
    end
    else
    begin
      BoxNameLabel1.Caption := '';
      BoxNameLabel2.Caption := 'not used';
      BoxNameLabel3.Caption := '';
      BoxNameLabel6.Caption := '';
      BoxNameLabel5.Caption := '';
      BoxNameLabel4.Caption := '';
    end;

    UIColorLabel.Enabled := True;
    UIColorLabel.Caption := 'Mesh color index: ' + IntToStr(MeshColor);

    if UseProc then
    begin
      ProcDataLabel.Caption := 'not used';
      ProcNameLabel.Caption := '';
      ProcSizeLabel.Caption := '';
    end
    else
    begin
      ProcDataLabel.Caption := Format('Data: %p', [ProcData]);
      ProcNameLabel.Caption := 'Name: ' + ProcName;
      ProcSizeLabel.Caption := Format('Data size: %d', [ProcSize]);
    end;

    for I := 0 to 3 do
      for J := 0 to 2 do
      begin
        MapMatrixGrid.Cells[J, I] := Format('%.3g', [Map.Matrix[I * 3 + J]]);
        MeshMatrixGrid.Cells[J, I] := Format('%.3g', [LocMatrix[I * 3 + J]]);
      end;
  end;
end;

//---------------------------------------------------------------------------------------------------------------------

procedure TMainForm.OmniListBoxClick(Sender: TObject);

begin
  with FReader.Objects.OmniLight[OmniListBox.ItemIndex]^ do
  begin
    if DLOff then OmniOnOffLabel.Caption := 'Shining: light is off'
             else OmniOnOffLabel.Caption := 'Shining: light is on';
    OmniOnOffLabel.Enabled := True;
    
    OmniPositionLabel.Caption := 'Position: ' + ConvertPoint(Pos);
    OmniPositionLabel.Enabled := True;

    OmniColorLabel.Caption := 'Color: ' + ConvertColor(Color);
    OmniColorLabel.Enabled := True;
    with OmniColorShape do
    begin
      Brush.Color := ConvertColor2(Color);
      Brush.Style := bsSolid;
    end;

    OmniIntensityLabel.Caption := Format('Intensity multiplier: %.3g', [Multiplier]);
    OmniIntensityLabel.Enabled := True;

    OmniExclusionBox.Clear;
    OmniExclusionBox.Items.AddStrings(Exclude);

    with Attenuation do
    begin
      if IsOn then
      begin
        OmniAttEnableLabel.Caption := 'is enabled';
        OmniAttInnerLabel.Caption := Format('Inner range: %.3g', [Inner]);
        OmniAttOuterLabel.Caption := Format('Outer range: %.3g', [Outer]);
      end
      else
      begin
        OmniAttEnableLabel.Caption := 'is disabled';
        OmniAttInnerLabel.Caption := '';
        OmniAttOuterLabel.Caption := '';
      end;
      OmniAttEnableLabel.Enabled := True;
      OmniAttInnerLabel.Enabled := True;
      OmniAttOuterLabel.Enabled := True;
    end;
  end;
end;

//---------------------------------------------------------------------------------------------------------------------

procedure TMainForm.SpotListBoxClick(Sender: TObject);

begin
  with FReader.Objects.SpotLight[SpotListBox.ItemIndex]^ do
  begin
    if DLOff then SpotOnOffLabel.Caption := 'Shining: light is off'
             else SpotOnOffLabel.Caption := 'Shining: light is on';
    SpotOnOffLabel.Enabled := True;
    
    SpotPositionLabel.Caption := 'Position: ' + ConvertPoint(Pos);
    SpotPositionLabel.Enabled := True;

    SpotColorLabel.Caption := 'Color: ' + ConvertColor(Color);
    SpotColorLabel.Enabled := True;
    with SpotColorShape do
    begin
      Brush.Color := ConvertColor2(Color);
      Brush.Style := bsSolid;
    end;

    SpotIntensityLabel.Caption := Format('Intensity multiplier: %.3g', [Multiplier]);
    SpotIntensityLabel.Enabled := True;

    SpotExclusionBox.Clear;
    SpotExclusionBox.Items.AddStrings(Exclude);

    with Attenuation do
    begin
      if IsOn then
      begin
        SpotAttEnableLabel.Caption := 'is enabled';
        SpotAttInnerLabel.Caption := Format('Inner range: %.3g', [Inner]);
        SpotAttOuterLabel.Caption := Format('Outer range: %.3g', [Outer]);
      end
      else
      begin
        SpotAttEnableLabel.Caption := 'is disabled';
        SpotAttInnerLabel.Caption := '';
        SpotAttOuterLabel.Caption := '';
      end;
      SpotAttEnableLabel.Enabled := True;
      SpotAttInnerLabel.Enabled := True;
      SpotAttOuterLabel.Enabled := True;
    end;

    with Spot^ do
    begin
      with SpotTargetLabel do
      begin
        Caption := 'Point to: ' + ConvertPoint(Target);
        Enabled := True;
      end;
      with SpotHotspotLabel do
      begin
        Caption := Format('Hotspot angle: %.3g', [Hotspot]);
        Enabled := True;
      end;
      with SpotFalloffLabel do
      begin
        Caption := Format('Fall off angle: %.3g', [FallOff]);
        Enabled := True;
      end;
      with SpotRollLabel do
      begin
        Caption := Format('Roll angle: %.3g', [Roll]);
        Enabled := True;
      end;
      with SpotAspectLabel do
      begin
        Caption := Format('Aspect ratio: %.3g', [Aspect]);
        Enabled := True;
      end;
      with Shadows do
      begin
        with SpotCastLabel do
        begin
          if Cast then Caption := 'cast shadows'
                  else Caption := 'don''t cast shadows';
          Enabled := True;
        end;
        with SpotShadowStyleLabel do
        begin
          if AType = ssUseShadowMap then Caption := 'Style: shadow map'
                                    else Caption := 'Style: ray tracing';
          Enabled := True;
        end;
        with SpotLocalLabel do
        begin
          if Local then Caption := 'Local settings are used'
                   else Caption := 'Local settings are not used';
          Enabled := True;
        end;
        with SpotFilterLabel do
        begin
          Caption := Format('Filter: %.3g', [Filter]);
          Enabled := True;
        end;
        with SpotBiasLabel do
        begin
          Caption := Format('Bias: %.3g', [Bias]);
          Enabled := True
        end;
        with SpotRayBiasLabel do
        begin
          Caption := Format('Ray bias: %.3g', [RayBias]);
          Enabled := True
        end;
        with SpotMapLabel do
        begin
          Caption := Format('Map size: %d', [MapSize]);
          Enabled := True
        end;
      end;
      with Cone do
      begin
        with SpotConeShowLabel do
        begin
          if Cone.Show then Caption := 'show cone'
                       else Caption := 'cone is not shown';
          Enabled := True
        end;
        with SpotConeTypeLabel do
        begin
          if AType = csCircular then Caption := 'Cone type is circular'
                                else Caption := 'Cone type is rectangular';
          Enabled := True;
        end;
        with SpotOvershootLabel do
        begin
          if Overshoot then Caption := 'Overshoot is used'
                       else Caption := 'Overshoot is not used';
          Enabled := True;
        end;
      end;
      with Projector do
      begin
        with SpotProjectorUseLabel do
        begin
          if Use then Caption := 'is used'
                 else Caption := 'is not used';
          Enabled := True;
        end;
        with SpotBitmapLabel do
        begin
          Caption := 'Projector bitmap: ' + Bitmap;
          Enabled := True;
        end;
      end;
    end;
  end;
end;

//---------------------------------------------------------------------------------------------------------------------

procedure TMainForm.CameraListBoxClick(Sender: TObject);

begin
  with FReader.Objects.Camera[CameraListBox.ItemIndex]^ do
  begin
    with CameraPositionLabel do
    begin
      Caption := 'Position: ' + ConvertPoint(Position);
      Enabled := True;
    end;
    with CameraTargetLabel do
    begin
      Caption := 'Look at: ' + ConvertPoint(Target);
      Enabled := True;
    end;
    with CameraRollLabel do
    begin
      Caption := Format('Roll angle: %.3g', [Roll]);
      Enabled := True;
    end;
    with CameraFOVLabel do
    begin
      Caption := Format('Field of view angle: %.3g', [FOV]);
      Enabled := True;
    end;
    with CameraConeLabel do
    begin
      if ShowCOne then Caption := 'Show cone: yes'
                  else Caption := 'Show cone: no';
      Enabled := True;
    end;
    with CameraNearLabel do
    begin
      Caption := Format('Near range: %.3g', [Ranges.CamNear]);
      Enabled := True;
    end;
    with CameraFarLabel do
    begin
      Caption := Format('Far range: %.3g', [Ranges.CamFar]);
      Enabled := True;
    end;
  end;
end;

//---------------------------------------------------------------------------------------------------------------------

procedure TMainForm.MaterialListBoxClick(Sender: TObject);

const ShadeToString: array[TShadeType3DS] of String= ('Wire', 'Flat', 'Gouraud', 'Phong', 'Metal');

begin
  with FReader.Materials[MaterialListBox.ItemIndex]^, MaterialPropBox do
  begin
    // start with flags
    State[0] := BooleanToCheckState[UseBlur];
    State[1] := BooleanToCheckState[UseFall];
    State[2] := BooleanToCheckState[TwoSided];
    State[3] := BooleanToCheckState[SelFillum];
    State[4] := BooleanToCheckState[Additive];
    State[5] := BooleanToCheckState[UseWire];
    State[6] := BooleanToCheckState[UseWireAbs];
    State[7] := BooleanToCheckState[FaceMap];
    State[8] := BooleanToCheckState[Soften];

    with MatAmbientLabel do
    begin
      Caption := 'Ambient color: ' + ConvertColor(Ambient);
      Enabled := True;
    end;
    with MatAmbientShape do
    begin
      Brush.Color := ConvertColor2(Ambient);
      Brush.Style := bsSolid;
    end;
    with MatDiffuseLabel do
    begin
      Caption := 'Diffuse color: ' + ConvertColor(Diffuse);
      Enabled := True;
    end;
    with MatDiffuseShape do
    begin
      Brush.Color := ConvertColor2(Diffuse);
      Brush.Style := bsSolid;
    end;
    with MatSpecularLabel do
    begin
      Caption := 'Specular color: ' + ConvertColor(Specular);
      Enabled := True;
    end;
    with MatSpecularShape do
    begin
      Brush.Color := ConvertColor2(Specular);
      Brush.Style := bsSolid;
    end;

    with MatWireSizeLabel do
    begin
      Caption := Format('Wire size: %.3g', [WireSize]);
      Enabled := True;
    end;
    with MatBlurLabel do
    begin
      Caption := Format('Blur factor: %.3g', [Blur]);
      Enabled := True;
    end;
    with MatShinStrengthLabel do
    begin
      Caption := Format('shininess strength: %.3g', [ShinStrength]);
      Enabled := True;
    end;
    with MatShininessLabel do
    begin
      Caption := Format('shininess factor: %.3g', [Shininess]);
      Enabled := True;
    end;
    with MatShadingLabel do
    begin
      Caption := 'Shading type: ' + ShadeToString[Shading];
      Enabled := True;
    end;
    with MatSelfIllumLabel do
    begin
      Caption := Format('self illumination: %d %%', [Round(100 * SelfIllumPct)]);
      Enabled := True;
    end;
    with MatTransFallOffLabel do
    begin
      Caption := Format('transparency fall off: %.3g', [TransFallOff]);
      Enabled := True;
    end;
    with MatTransparencyLabel do
    begin
      Caption := Format('Transparency factor: %.3g', [Transparency]);
      Enabled := True;
    end;

    with SpeedButton1 do Enabled := True;
    with SpeedButton2 do Enabled := True;
    with SpeedButton3 do Enabled := True;
    with SpeedButton4 do Enabled := True;
    with SpeedButton5 do Enabled := True;
    with SpeedButton6 do Enabled := True;
    with SpeedButton7 do Enabled := True;
    with SpeedButton8 do Enabled := True;
  end;
  // refresh map settings viewer
  MapSettingsClick(nil);
end;

//---------------------------------------------------------------------------------------------------------------------

procedure TMainForm.DoLoad(const FileName: String);

const DBTypeToString: array[TDBType3DS] of String = ('unkown (invalid?) file', '3D Studio object file',
                                                     '3D Studio project file', '3D Studio material file');
      DBReleaseToString: array[TReleaseLevel] of String = ('3D Studio R1', '3D Studio R2',
                                                           '3D Studio R3', 'release unkown');
      MeshReleaseToString: array[TReleaseLevel] of String = ('Version 1', 'Version 2',
                                                             'Version 3', 'release unkown');

var I: Integer;

begin
  Screen.Cursor := crHourGlass;
  try
    ClearAndGrayControls;
    ProgressMessage('preparing structures...');
    // release old file ...
    FReader.ClearLists;
    // ...and load the new one
    ProgressMessage('loading file database...');
    FReader.LoadFromFile(FileName);
    StatusBar.SimpleText := '  File loaded: ' + FileName;
    StatusBar.Update;
    
    // actualize MRU list
    I := FMRUFiles.IndexOf(FileName);
    if I > -1 then FMRUFiles.Delete(I);
    FMRUFiles.Insert(0, FileName);

    // collect info
    with FReader,  Objects do
    begin
      ProgressMessage('reading global settings...');
      AddHeader(False, 'Database type');
      AddInfo(False, DBTypeToString[DatabaseType]);
      AddNewLine(False);
      AddHeader(False, 'Database release');
      AddInfo(False, DBReleaseToString[DatabaseRelease]);
      AddNewLine(False);
      AddHeader(False, 'Mesh release');
      AddInfo(False, MeshReleaseToString[MeshRelease]);
      AddNewLine(False);
      // other global settings
      ProgressMessage('reading atmosphere settings...');
      ShowAtmosphereSettings;
      ProgressMessage('reading background settings...');
      ShowBackgroundSettings;
      ProgressMessage('reading mesh settings...');
      ShowMeshSettings;
      ProgressMessage('reading viewport settings...');
      ShowViewportSettings;
      if DatabaseType <> dbMaterialFile then
      begin
        // keyframer global settings
        ProgressMessage('reading animation settings...');
        ShowAnimationSettings;
        ProgressMessage('reading ambient animation settings...');
        ShowAmbientAnimation;

        ProgressMessage('reading meshs...');
        for I := 0 to MeshCount - 1 do
        begin
          if Mesh[I].Name = '' then
          begin
            MeshListBox.Items.Add('(no name)');
            ProgressMessage('mesh without a name read');
          end
          else
          begin
            MeshListBox.Items.Add(Mesh[I].Name);
            ProgressMessage('mesh "' + Mesh[I].Name + '" read');
          end;
        end;
        // activate first entry if available
        if MeshCount > 0 then
        begin
          MeshListBox.ItemIndex := 0;
          MeshListBoxClick(MeshListBox);
        end;

        ProgressMessage('reading omni light sources...');
        for I := 0 to OmniLightCount - 1 do
        begin
          if OmniLight[I].Name = '' then
          begin
            OmniListBox.Items.Add('(no name)');
            ProgressMessage('omnilight without a name read');
          end
          else
          begin
            OmniListBox.Items.Add(OmniLight[I].Name);
            ProgressMessage('omni light "' + OmniLight[I].Name + '" read');
          end;
        end;
        // activate first entry if available
        if OmniLightCount > 0 then
        begin
          OmniListBox.ItemIndex := 0;
          OmniListBoxClick(OmniListBox);
        end;

        ProgressMessage('reading spot light sources...');
        for I := 0 to SpotLightCount - 1 do
        begin
          if SpotLight[I].Name = '' then
          begin
            SpotListBox.Items.Add('(no name)');
            ProgressMessage('spot light without a name read');
          end
          else
          begin
            SpotListBox.Items.Add(SpotLight[I].Name);
            ProgressMessage('spot light "' + SpotLight[I].Name + '" read');
          end;
        end;
        // activate first entry if available
        if SpotLightCount > 0 then
        begin
          SpotListBox.ItemIndex := 0;
          SpotListBoxClick(SpotListBox);
        end;

        ProgressMessage('reading cameras...');
        for I := 0 to CameraCount - 1 do
        begin
          if Camera[I].Name = '' then
          begin
            CameraListBox.Items.Add('(no name)');
            ProgressMessage('camera without a name read');
          end
          else
          begin
            CameraListBox.Items.Add(Camera[I].Name);
            ProgressMessage('camera "' + Camera[I].Name + '" read');
          end;
        end;
        // activate first entry if available
        if CameraCount > 0 then
        begin
          CameraListBox.ItemIndex := 0;
          CameraListBoxClick(CameraListBox);
        end;
      end;
      
      ProgressMessage('reading materials...');
      for I := 0 to Materials.Count - 1 do
      begin
        if Materials[I].Name = '' then
        begin
          MaterialListBox.Items.Add('(no name)');
          ProgressMessage('material without a name read');
        end
        else
        begin
          MaterialListBox.Items.Add(Materials[I].Name);
          ProgressMessage('material "' + Materials[I].Name + '" read');
        end;
      end;
      // activate first entry if available
      if Materials.Count > 0 then
      begin
        MaterialListBox.ItemIndex := 0;
        MaterialListBoxClick(MaterialListBox);
      end;

      if DatabaseType <> dbMaterialFile then
      begin
        // animation settings
        with Keyframer do
        begin
          ProgressMessage('reading mesh motions...');
          for I := 0 to MeshMotionCount - 1 do
          begin
            if MeshMotion[I].Name = '' then
            begin
              MeshMotionListBox.Items.Add('(no name)');
              ProgressMessage('mesh motion read');
            end
            else
            begin
              MeshMotionListBox.Items.Add(MeshMotion[I].Name);
              ProgressMessage('mesh motion for "' + MeshMotion[I].Name + '" read');
            end;
          end;
          // activate first entry if available
          if MeshMotionCount > 0 then
          begin
            MeshMotionListBox.ItemIndex := 0;
            MeshMotionListBoxClick(MeshListBox);
          end;

          ProgressMessage('reading omni light motions...');
          for I := 0 to OmniLightMotionCount - 1 do
          begin
            if OmniLightMotion[I].Name = '' then
            begin
              OmniMotionListBox.Items.Add('(no name)');
              ProgressMessage('omnilight without motion read');
            end
            else
            begin
              OmniMotionListBox.Items.Add(OmniLightMotion[I].Name);
              ProgressMessage('omni light motion for "' + OmniLightMotion[I].Name + '" read');
            end;
          end;
          // activate first entry if available
          if OmniLightMotionCount > 0 then
          begin
            OmniMotionListBox.ItemIndex := 0;
            OmniMotionListBoxClick(OmniMotionListBox);
          end;

          ProgressMessage('reading spot light motions...');
          for I := 0 to SpotLightMotionCount - 1 do
          begin
            if SpotLightMotion[I].Name = '' then
            begin
              SpotMotionListBox.Items.Add('(no name)');
              ProgressMessage('spot light motion read');
            end
            else
            begin
              SpotMotionListBox.Items.Add(SpotLightMotion[I].Name);
              ProgressMessage('spot light motion for "' + SpotLightMotion[I].Name + '" read');
            end;
          end;
          // activate first entry if available
          if SpotLightMotionCount > 0 then
          begin
            SpotMotionListBox.ItemIndex := 0;
            SpotMotionListBoxClick(SpotMotionListBox);
          end;

          ProgressMessage('reading camera montions...');
          for I := 0 to CameraMotionCount - 1 do
          begin
            if CameraMotion[I].Name = '' then
            begin
              CameraMotionListBox.Items.Add('(no name)');
              ProgressMessage('camera motion read');
            end
            else
            begin
              CameraMotionListBox.Items.Add(CameraMotion[I].Name);
              ProgressMessage('camera motion for "' + Camera[I].Name + '" read');
            end;
          end;
          // activate first entry if available
          if CameraMotionCount > 0 then
          begin
            CameraMotionListBox.ItemIndex := 0;
            CameraMotionListBoxClick(CameraMotionListBox);
          end;
        end;
      end;  
    end;
    Application.ProcessMessages;
    ViewerForm.Use3DSData(FReader);
    DumpGroup.ItemIndex := -1;
  finally
    Screen.Cursor := crDefault;
    HideProgress;
  end;
end;

//---------------------------------------------------------------------------------------------------------------------

procedure TMainForm.LoadButtonClick(Sender: TObject);

begin
  if Open3DS.Execute then DoLoad(Open3DS.FileName);
end;

//---------------------------------------------------------------------------------------------------------------------

procedure TMainForm.CloseButtonClick(Sender: TObject);

begin
  Close;
end;

//---------------------------------------------------------------------------------------------------------------------

procedure TMainForm.ClearAndGrayControls;

// gray out all controls to show no valid selection

const NullSelection : TGridRect = (Left: -1; Top: -1; Right: -1; Bottom: -1);

var I, J: Integer;

begin
  // meshs
  with MeshPropBox do
    for I := 0 to Items.Count - 1 do State[I] := cbGrayed;
  VertCountLabel.Caption := '0 vertices';
  VertCountLabel.Enabled := False;
  VFlagCountLabel.Caption := '0 vertex flags';
  VFlagCountLabel.Enabled := False;
  TexCountLabel.Caption := '0 texture coordinates';
  TexCountLabel.Enabled := False;
  FaceCountLabel.Caption := '0 faces';
  FaceCountLabel.Enabled := False;
  MatCountLabel.Caption := '0 used materials';
  MatCountLabel.Enabled := False;

  for I := 0 to 3 do
    for J := 0 to 2 do
    begin
      MapMatrixGrid.Cells[J, I] := '0';
      MeshMatrixGrid.Cells[J, I] := '0';
    end;
  MapMatrixGrid.Selection := NullSelection;
  MeshMatrixGrid.Selection := NullSelection;

  MapTypeLabel.Caption := 'no info avail.';
  TilingLabel.Caption := '';
  CenterLabel.Caption := '';
  CylinderLabel.Caption := '';
  IconSizeLabel.Caption := '';
  ScaleLabel.Caption := '';

  BoxNameLabel1.Caption := '';
  BoxNameLabel2.Caption := 'no info avail.';
  BoxNameLabel3.Caption := '';
  BoxNameLabel6.Caption := '';
  BoxNameLabel5.Caption := '';
  BoxNameLabel4.Caption := '';

  UIColorLabel.Enabled := False;
  UIColorLabel.Caption := 'Mesh color index: ?';

  ProcDataLabel.Caption := 'no info avail.';
  ProcNameLabel.Caption := '';
  ProcSizeLabel.Caption := '';

  // omni lights
  OmniOnOffLabel.Caption := 'Shining: ?';
  OmniOnOffLabel.Enabled := False;
  OmniPositionLabel.Caption := 'Position: ?';
  OmniPositionLabel.Enabled := False;
  OmniColorLabel.Caption := 'Color: ?';
  OmniColorLabel.Enabled := False;
  OmniIntensityLabel.Caption := 'Intensity multiplier: ?';
  OmniIntensityLabel.Enabled := False;
  OmniExclusionBox.Clear;
  OmniAttEnableLabel.Caption := 'no info avail.';
  OmniAttEnableLabel.Enabled := False;
  OmniAttInnerLabel.Caption := '';
  OmniAttInnerLabel.Enabled := False;
  OmniAttOuterLabel.Caption := '';
  OmniAttOuterLabel.Enabled := False;
  with OmniColorShape.Brush do begin Color := clBlack; Style := bsDiagCross; end;

  // spot ligts
  SpotOnOffLabel.Caption := 'Shining: ?';
  SpotOnOffLabel.Enabled := False;
  SpotPositionLabel.Caption := 'Position: ?';
  SpotPositionLabel.Enabled := False;
  SpotColorLabel.Caption := 'Color: ?';
  SpotColorLabel.Enabled := False;
  SpotIntensityLabel.Caption := 'Intensity multiplier: ?';
  SpotIntensityLabel.Enabled := False;
  SpotExclusionBox.Clear;
  SpotAttEnableLabel.Caption := 'no info avail.';
  SpotAttEnableLabel.Enabled := False;
  SpotAttInnerLabel.Caption := '';
  SpotAttInnerLabel.Enabled := False;
  SpotAttOuterLabel.Caption := '';
  SpotAttOuterLabel.Enabled := False;
  with SpotColorShape.Brush do begin Color := clBlack; Style := bsDiagCross; end;

  with SpotTargetLabel do begin Caption := 'Point to: ?'; Enabled := False; end;
  with SpotHotspotLabel do begin Caption := 'Hotspot angle: ?'; Enabled := False; end;
  with SpotFalloffLabel do begin Caption := 'Fall off angle: ?'; Enabled := False; end;
  with SpotRollLabel do begin Caption := 'Roll angle: ?'; Enabled := False; end;
  with SpotAspectLabel do begin Caption := 'Aspect ratio: ?'; Enabled := False; end;
  with SpotCastLabel do begin Caption := 'no info avail.'; Enabled := False; end;
  with SpotShadowStyleLabel do begin Caption := 'Style: ?'; Enabled := False; end;
  with SpotLocalLabel do begin Caption := 'Local settings: ?'; Enabled := False; end;
  with SpotFilterLabel do begin Caption := 'Filter: ?'; Enabled := False; end;
  with SpotBiasLabel do begin Caption := 'Bias: ?'; Enabled := False; end;
  with SpotRayBiasLabel do begin Caption := 'Ray bias: ?'; Enabled := False; end;
  with SpotMapLabel do begin Caption := 'Map size: ?'; Enabled := False; end;
  with SpotConeShowLabel do begin Caption := 'no info avail.'; Enabled := False; end;
  with SpotConeTypeLabel do begin Caption := 'Cone type: ?'; Enabled := False; end;
  with SpotOvershootLabel do begin Caption := 'Overshoot: ?'; Enabled := False; end;
  with SpotBitmapLabel do begin Caption := 'Projector bitmap: ?'; Enabled := False; end;
  with SpotProjectorUseLabel do begin Caption := 'no info avail.'; Enabled := False; end;

  // cameras
  with CameraPositionLabel do begin Caption := 'Position: ?'; Enabled := False; end;
  with CameraTargetLabel do begin Caption := 'Look at: ?'; Enabled := False; end;
  with CameraRollLabel do begin Caption := 'Roll angle: ?'; Enabled := False; end;
  with CameraFOVLabel do begin Caption := 'Field of view angle: ?'; Enabled := False; end;
  with CameraConeLabel do begin Caption := 'Show cone: ?'; Enabled := False; end;
  with CameraNearLabel do begin Caption := 'Near range: ?'; Enabled := False; end;
  with CameraFarLabel do begin Caption := 'Far range: ?'; Enabled := False; end;

  // materials
  with MaterialPropBox do
    for I := 0 to Items.Count - 1 do State[I] := cbGrayed;
  with MatAmbientLabel do begin Caption := 'Ambient color: ?'; Enabled := False; end;
  with MatDiffuseLabel do begin Caption := 'Diffuse color: ?'; Enabled := False; end;
  with MatSpecularLabel do begin Caption := 'Specular color: ?'; Enabled := False; end;

  with MatWireSizeLabel do begin Caption := 'Wire size: ?'; Enabled := False; end;
  with MatBlurLabel do begin Caption := 'Blur factor: ?'; Enabled := False; end;
  with MatShinStrengthLabel do begin Caption := 'shininess strength: ?'; Enabled := False; end;
  with MatShininessLabel do begin Caption := 'shininess factor: ?'; Enabled := False; end;
  with MatShadingLabel do begin Caption := 'Shading type: ?'; Enabled := False; end;
  with MatSelfIllumLabel do begin Caption := 'self illumination: ?'; Enabled := False; end;
  with MatTransFallOffLabel do begin Caption := 'transparency fall off: ?'; Enabled := False; end;
  with MatTransparencyLabel do begin Caption := 'Transparency factor: ?'; Enabled := False; end;

  with SpeedButton1 do Enabled := False;
  with SpeedButton2 do Enabled := False;
  with SpeedButton3 do Enabled := False;
  with SpeedButton4 do Enabled := False;
  with SpeedButton5 do Enabled := False;
  with SpeedButton6 do Enabled := False;
  with SpeedButton7 do Enabled := False;
  with SpeedButton8 do Enabled := False;
  with MatAmbientShape.Brush do begin Color := clBlack; Style := bsDiagCross; end;
  with MatDiffuseShape.Brush do begin Color := clBlack; Style := bsDiagCross; end;
  with MatSpecularShape.Brush do begin Color := clBlack; Style := bsDiagCross; end;

  // mesh animation
  with MParentLabel do begin Caption := 'Parent object: ?'; Enabled := False; end;
  with MFlags1Label do begin Caption := 'Node flags 1: ?'; Enabled := False; ShowHint := False; end;
  with MFlags2Label do begin Caption := 'Node flags 2: ?'; Enabled := False; ShowHint := False; end;
  with MPivotLabel do begin Caption := 'Pivot point: ?'; Enabled := False; end;
  with MMinBoundLabel do begin Caption := 'Minimum bound point: ?'; Enabled := False; end;
  with MMaxBoundLabel do begin Caption := 'Maximum bound point: ?'; Enabled := False; end;
  with MMSAngleLabel do begin Caption := 'Morph smoothing group angle:: ?'; Enabled := False; end;

  MPKListBox.Clear;
  SendMessage(MPKListBox.Handle, LB_SETHORIZONTALEXTENT, 0, 0);
  with MPKCountLabel do begin Caption := 'Key count: ?'; Enabled := False; end;
  with MPKFlagsLabel do begin Caption := 'Flag: ?'; Enabled := False; ShowHint := False; end;
  MRKListBox.Clear;
  SendMessage(MRKListBox.Handle, LB_SETHORIZONTALEXTENT, 0, 0);
  with MRKCountLabel do begin Caption := 'Key count: ?'; Enabled := False; end;
  with MRKFlagsLabel do begin Caption := 'Flag: ?'; Enabled := False; ShowHint := False; end;
  MSKListBox.Clear;
  SendMessage(MSKListBox.Handle, LB_SETHORIZONTALEXTENT, 0, 0);
  with MSKCountLabel do begin Caption := 'Key count: ?'; Enabled := False; end;
  with MSKFlagsLabel do begin Caption := 'Flag: ?'; Enabled := False; ShowHint := False; end;
  MMKListBox.Clear;
  SendMessage(MMKListBox.Handle, LB_SETHORIZONTALEXTENT, 0, 0);
  with MMKCountLabel do begin Caption := 'Key count: ?'; Enabled := False; end;
  with MMKFlagsLabel do begin Caption := 'Flag: ?'; Enabled := False; ShowHint := False; end;
  MHKListBox.Clear;
  SendMessage(MHKListBox.Handle, LB_SETHORIZONTALEXTENT, 0, 0);
  with MHKCountLabel do begin Caption := 'Key count: ?'; Enabled := False; end;
  with MHKFlagsLabel do begin Caption := 'Flag: ?'; Enabled := False; ShowHint := False; end;

  // light animation
  with OParentLabel do begin Caption := 'Parent object: ?'; Enabled := False; end;
  with OFlags1Label do begin Caption := 'Node flags 1: ?'; Enabled := False; ShowHint := False; end;
  with OFlags2Label do begin Caption := 'Node flags 2: ?'; Enabled := False; ShowHint := False; end;

  OPKListBox.Clear;
  SendMessage(OPKListBox.Handle, LB_SETHORIZONTALEXTENT, 0, 0);
  with OPKCountLabel do begin Caption := 'Key count: ?'; Enabled := False; end;
  with OPKFlagsLabel do begin Caption := 'Flag: ?'; Enabled := False; ShowHint := False; end;
  OCKListBox.Clear;
  SendMessage(OCKListBox.Handle, LB_SETHORIZONTALEXTENT, 0, 0);
  with OCKCountLabel do begin Caption := 'Key count: ?'; Enabled := False; end;
  with OCKFlagsLabel do begin Caption := 'Flag: ?'; Enabled := False; ShowHint := False; end;

  with SParentLabel do begin Caption := 'Parent object: ?'; Enabled := False; end;
  with SFlags1Label do begin Caption := 'Node flags 1: ?'; Enabled := False; ShowHint := False; end;
  with SFlags2Label do begin Caption := 'Node flags 2: ?'; Enabled := False; ShowHint := False; end;

  SPKListBox.Clear;
  SendMessage(SPKListBox.Handle, LB_SETHORIZONTALEXTENT, 0, 0);
  with SPKCountLabel do begin Caption := 'Key count: ?'; Enabled := False; end;
  with SPKFlagsLabel do begin Caption := 'Flag: ?'; Enabled := False; ShowHint := False; end;
  SCKListBox.Clear;
  SendMessage(SCKListBox.Handle, LB_SETHORIZONTALEXTENT, 0, 0);
  with SCKCountLabel do begin Caption := 'Key count: ?'; Enabled := False; end;
  with SCKFlagsLabel do begin Caption := 'Flag: ?'; Enabled := False; ShowHint := False; end;
  SHKListBox.Clear;
  SendMessage(SHKListBox.Handle, LB_SETHORIZONTALEXTENT, 0, 0);
  with SHKCountLabel do begin Caption := 'Key count: ?'; Enabled := False; end;
  with SHKFlagsLabel do begin Caption := 'Flag: ?'; Enabled := False; ShowHint := False; end;
  SFKListBox.Clear;
  SendMessage(SFKListBox.Handle, LB_SETHORIZONTALEXTENT, 0, 0);
  with SFKCountLabel do begin Caption := 'Key count: ?'; Enabled := False; end;
  with SFKFlagsLabel do begin Caption := 'Flag: ?'; Enabled := False; ShowHint := False; end;
  SRKListBox.Clear;
  SendMessage(SRKListBox.Handle, LB_SETHORIZONTALEXTENT, 0, 0);
  with SRKCountLabel do begin Caption := 'Key count: ?'; Enabled := False; end;
  with SRKFlagsLabel do begin Caption := 'Flag: ?'; Enabled := False; ShowHint := False; end;
  STKListBox.Clear;
  SendMessage(STKListBox.Handle, LB_SETHORIZONTALEXTENT, 0, 0);
  with STKCountLabel do begin Caption := 'Key count: ?'; Enabled := False; end;
  with STKFlagsLabel do begin Caption := 'Flag: ?'; Enabled := False; ShowHint := False; end;
  with STKParentLabel do begin Caption := 'Target parent: ?'; Enabled := False; end;

  // camera animation
  with CParentLabel do begin Caption := 'Parent object: ?'; Enabled := False; end;
  with CFlags1Label do begin Caption := 'Node flags 1: ?'; Enabled := False; ShowHint := False; end;
  with CFlags2Label do begin Caption := 'Node flags 2: ?'; Enabled := False; ShowHint := False; end;

  CPKListBox.Clear;
  SendMessage(CPKListBox.Handle, LB_SETHORIZONTALEXTENT, 0, 0);
  with CPKCountLabel do begin Caption := 'Key count: ?'; Enabled := False; end;
  with CPKFlagsLabel do begin Caption := 'Flag: ?'; Enabled := False; ShowHint := False; end;
  CFKListBox.Clear;
  SendMessage(CFKListBox.Handle, LB_SETHORIZONTALEXTENT, 0, 0);
  with CFKCountLabel do begin Caption := 'Key count: ?'; Enabled := False; end;
  with CFKFlagsLabel do begin Caption := 'Flag: ?'; Enabled := False; ShowHint := False; end;
  CRKListBox.Clear;
  SendMessage(CRKListBox.Handle, LB_SETHORIZONTALEXTENT, 0, 0);
  with CRKCountLabel do begin Caption := 'Key count: ?'; Enabled := False; end;
  with CRKFlagsLabel do begin Caption := 'Flag: ?'; Enabled := False; ShowHint := False; end;
  CTKListBox.Clear;
  SendMessage(CTKListBox.Handle, LB_SETHORIZONTALEXTENT, 0, 0);
  with CTKCountLabel do begin Caption := 'Key count: ?'; Enabled := False; end;
  with CTKFlagsLabel do begin Caption := 'Flag: ?'; Enabled := False; ShowHint := False; end;
  with CTKParentLabel do begin Caption := 'Target parent: ?'; Enabled := False; end;

  // other stuff
  OGlobalsMemo.Lines.Clear;
  KFGlobalsMemo.Lines.Clear;
  StructureTree.Items.Clear;
  // set tab positions
  for I := 0 to 9 do
    OGlobalsMemo.Paragraph.Tab[I] := (I + 1) * 8;
  for I := 0 to 9 do
    KFGlobalsMemo.Paragraph.Tab[I] := (I + 1) * 8;

  MeshListBox.Clear;
  OmniListBox.Clear;
  SpotListBox.Clear;
  CameraListBox.Clear;
  MaterialListBox.Clear;
  MeshMotionListBox.Clear;
  OmniMotionListBox.Clear;
  SpotMotionListBox.Clear;
  CameraMotionListBox.Clear;
  Application.ProcessMessages;
end;

//---------------------------------------------------------------------------------------------------------------------

procedure TMainForm.MapSettingsClick(Sender: TObject);

var Button: TSpeedButton;

begin
  Button := Sender as TSpeedButton;
  if Button = nil then
  begin
    // nil if MaterialListBox index has changed
    if SpeedButton1.Down then Button := SpeedButton1;
    if SpeedButton2.Down then Button := SpeedButton2;
    if SpeedButton3.Down then Button := SpeedButton3;
    if SpeedButton4.Down then Button := SpeedButton4;
    if SpeedButton5.Down then Button := SpeedButton5;
    if SpeedButton6.Down then Button := SpeedButton6;
    if SpeedButton7.Down then Button := SpeedButton7;
    if SpeedButton8.Down then Button := SpeedButton8;
  end;

  if Assigned(Button) then
    with Button, FReader.Materials[MaterialListBox.ItemIndex]^ do
      if not Down then BitmapForm.Hide
                  else
      case Tag of
        1:
          BitmapForm.Show(Name + '.Texture2', @Texture2.Map, @Texture2.Mask, False);
        2:
          BitmapForm.Show(Name + '.Opacity', @Opacity.Map, @Opacity.Mask, False);
        3:
          BitmapForm.Show(Name + '.Bump', @Bump.Map, @Bump.Mask, False);
        4:
          BitmapForm.Show(Name + '.Specularity', @SpecMap.Map, @SpecMap.Mask, False);
        5:
          BitmapForm.Show(Name + '.Shininess', @ShinMap.Map, @ShinMap.Mask, False);
        6:
          BitmapForm.Show(Name + '.Self illumination', @IllumMap.Map, @IllumMap.Mask, False);
        7:
          BitmapForm.Show(Name + '.Reflection', @Reflect.Map, @Reflect.Mask, True, Reflect.UseAuto, @Reflect.Automap);
      else
        // default texture
        BitmapForm.Show(Name + '.Texture', @Texture.Map, @Texture.Mask, False);
      end;
end;

//---------------------------------------------------------------------------------------------------------------------

procedure TMainForm.ToolButton4Click(Sender: TObject);

begin
  ViewerForm.Show;
end;

//---------------------------------------------------------------------------------------------------------------------

procedure TMainForm.PickPathButtonClick(Sender: TObject);

var S: String;
    I: Integer;

begin
  if SelectDirectory('Select default path to texture images:', '', S) then
  begin
    DefaultMapEdit.Text := S;
    // actualize MRU list
    I := DefaultMapEdit.Items.IndexOf(S);
    if I > -1 then DefaultMapEdit.Items.Delete(I);
    DefaultMapEdit.Items.Insert(0, S);
  end;
end;

//---------------------------------------------------------------------------------------------------------------------

function TMainForm.ConvertHeaderFlags1(Flags: Word): String;

begin
  Result := '';
  if (Flags and NODE_RENDOB_HIDE) <> 0 then Result := Result + 'Node renderob hide'#13#10;
  if (Flags and NODE_OFF) <> 0 then Result := Result + 'Node off'#13#10;
  if (Flags and MARK_NODE) <> 0 then Result := Result + 'Mark node'#13#10;
  if (Flags and DISABLE_NODE) <> 0 then Result := Result + 'Disabe node'#13#10;
  if (Flags and HIDE_NODE) <> 0 then Result := Result + 'Hide node'#13#10;
  if (Flags and FAST_NODE) <> 0 then Result := Result + 'Fast node'#13#10;
  if (Flags and PRIMARY_NODE) <> 0 then Result := Result + 'Primary node'#13#10;
  if (Flags and NODE_CALC_PATH) <> 0 then Result := Result + 'Node calc path'#13#10;
  if (Flags and ATKEY1) <> 0 then Result := Result + 'ATKEY 1'#13#10;
  if (Flags and ATKEY2) <> 0 then Result := Result + 'ATKEY 2'#13#10;
  if (Flags and ATKEY3) <> 0 then Result := Result + 'ATKEY 3'#13#10;
  if (Flags and ATKEY4) <> 0 then Result := Result + 'ATKEY 4'#13#10;
  if (Flags and ATKEY5) <> 0 then Result := Result + 'ATKEY 5'#13#10;
  if Result <> '' then Delete(Result, Length(Result) - 1, 2); // remove last CR/LF
end;

//---------------------------------------------------------------------------------------------------------------------

function TMainForm.ConvertHeaderFlags2(Flags: Word): String;

begin
  Result := '';
  if (Flags and NODE_HAS_PATH) <> 0 then Result := Result + 'Node has path'#13#10;
  if (Flags and NODE_AUTO_SMOOTH) <> 0 then Result := Result + 'Node auto smooth'#13#10;
  if (Flags and NODE_FROZEN) <> 0 then Result := Result + 'Node frozen'#13#10;
  if (Flags and NODE_ANI_HIDDEN) <> 0 then Result := Result + 'Node animation hidden'#13#10;
  if (Flags and NODE_MOTION_BLUR) <> 0 then Result := Result + 'Node motion blur'#13#10;
  if (Flags and NODE_BLUR_BRANCH) <> 0 then Result := Result + 'Node blur branch'#13#10;
  if (Flags and NODE_MORPH_MTL) <> 0 then Result := Result + 'Node morph MTL'#13#10;
  if (Flags and NODE_MORPH_OB) <> 0 then Result := Result + 'Node morph object'#13#10;
  if Result <> '' then Delete(Result, Length(Result) - 1, 2); // remove last CR/LF
end;

//---------------------------------------------------------------------------------------------------------------------

function TMainForm.ConvertLoopControlFlags(Flags: Word): String;

begin
  Result := '';
  if (Flags and TrackSingle3DS) <> 0 then Result := Result + 'track single'#13#10;
  if (Flags and TrackLoops3DS) <> 0 then Result := Result + 'track loops'#13#10;
  if (Flags and TrackRepeats3DS) <> 0 then Result := Result + 'track repeats'#13#10;
  if (Flags and TrackLockX3DS) <> 0 then Result := Result + 'track lock X'#13#10;
  if (Flags and TrackLockY3DS) <> 0 then Result := Result + 'track lock Y'#13#10;
  if (Flags and TrackLockZ3DS) <> 0 then Result := Result + 'track lock Z'#13#10;
  if (Flags and TrackNoLinkX3DS) <> 0 then Result := Result + 'track no link X'#13#10;
  if (Flags and TrackNoLinkY3DS) <> 0 then Result := Result + 'track no link Y'#13#10;
  if (Flags and TrackNoLinkZ3DS) <> 0 then Result := Result + 'track no link Z'#13#10;
  if Flags <> 0 then
  begin
    if Result <> '' then Delete(Result, Length(Result) - 1, 2) // remove last CR/LF
                    else Result := '1 or more unknown values in flag';
  end;
end;

//---------------------------------------------------------------------------------------------------------------------

function TMainForm.ConvertKeyHeader(Header: TKeyHeader3DS): String;

var S: String;

begin
  with Header do
  begin
    Result := Format('at frame: %d, spline flags: $%x;   ', [Time, RFlags]);
    S := '';
    if (RFlags and KeyUsesTension3DS) <> 0 then S := S + Format('tension: %.3g, ', [Tension]);
    if (RFlags and KeyUsesCont3DS) <> 0 then S := S + Format('Continuity: %.3g, ', [Continuity]);
    if (RFlags and KeyUsesBias3DS) <> 0 then S := S + Format('bias: %.3g, ', [Bias]);
    if (RFlags and KeyUsesEaseTo3DS) <> 0 then S := S + Format('ease to: %.3g, ', [EaseFrom]);
    if (RFlags and KeyUsesEaseFrom3DS) <> 0 then S := S + Format('ease from: %.3g, ', [EaseTo]);
    if S <> '' then
    begin
      Delete(S, Length(S) - 1, 2); // remove last comma/space
      Result := Result + '(' + S + ')   ';
    end;
  end;
end;

//---------------------------------------------------------------------------------------------------------------------

procedure TMainForm.MeshMotionListBoxClick(Sender: TObject);

var S: String;
    I: Integer;
    CurrentWidth,
    MaxWidth: Integer;

begin
  with FReader.Keyframer.MeshMotion[MeshMotionListBox.ItemIndex]^ do
  begin
    with MParentLabel do
    begin
      Enabled := True;
    end;
    if Parent = '' then MParentLabel.Caption := 'Parent object: none'
                   else MParentLabel.Caption := 'Parent object: ' + Parent;
    with MFlags1Label do
    begin
      Enabled := True;
      Caption := Format('Node flags 1: $%x', [Flags1]);
      ShowHint := True;
      Hint := ConvertHeaderFlags1(Flags1);
    end;
    with MFlags2Label do
    begin
      Enabled := True;
      Caption := Format('Node flags 2: $%x', [Flags2]);
      ShowHint := True;
      Hint := ConvertHeaderFlags2(Flags2);
    end;
    with MPivotLabel do
    begin
      Enabled := True;
      Caption := 'Pivot point: ' + ConvertPoint(Pivot);
    end;
    with MMinBoundLabel do
    begin
      Enabled := True;
      Caption := 'Min. bound: ' + ConvertPoint(BoundMin);
    end;
    with MMaxBoundLabel do
    begin
      Enabled := True;
      Caption := 'Max. bound: ' + ConvertPoint(BoundMax);
    end;
    with MMSAngleLabel do
    begin
      Enabled := True;
      Caption := Format('Morph smoothing group angle: %.3g', [MSAngle]);
    end;

    {$ifopt R+} {$R-} {$define RangeCheck} {$endif}
    // position keys
    with MPKCountLabel do
    begin
      Enabled := True;
      Caption := Format('Key count: %d', [NPKeys]);
    end;
    with MPKFlagsLabel do
    begin
      Enabled := True;
      ShowHint := True;
      Caption := Format('Flag: $%x', [NPFlag]);
      Hint := ConvertLoopControlFlags(NPFlag);
    end;
    with MPKListBox do
    begin
      Clear;
      MaxWidth := ClientWidth;
      for I := 0 to NPKeys - 1 do
      begin
        S := ConvertKeyHeader(PKeys[I]) + ConvertPoint(Pos[I]);
        Items.Add(S);
        CurrentWidth := Canvas.TextWidth(S);
        if CurrentWidth > MaxWidth then MaxWidth := CurrentWidth;
      end;
      // make the listbox also scrolling horizontally if necessary
      if MaxWidth > ClientWidth then Inc(MaxWidth, 20);
      SendMessage(Handle, LB_SETHORIZONTALEXTENT, MaxWidth, 0);
    end;
    
    // rotation keys
    with MRKCountLabel do
    begin
      Enabled := True;
      Caption := Format('Key count: %d', [NRKeys]);
    end;
    with MRKFlagsLabel do
    begin
      Enabled := True;
      ShowHint := True;
      Caption := Format('Flag: $%x', [NRFlag]);
      Hint := ConvertLoopControlFlags(NRFlag);
    end;
    with MRKListBox do
    begin
      Clear;
      MaxWidth := ClientWidth;
      for I := 0 to NRKeys - 1 do
      begin
        S := ConvertKeyHeader(RKeys[I]) + ConvertRotation(Rot[I]);
        Items.Add(S);
        CurrentWidth := Canvas.TextWidth(S);
        if CurrentWidth > MaxWidth then MaxWidth := CurrentWidth;
      end;
      if MaxWidth > ClientWidth then Inc(MaxWidth, 20);
      SendMessage(Handle, LB_SETHORIZONTALEXTENT, MaxWidth, 0);
    end;

    // scaling keys
    with MSKCountLabel do
    begin
      Enabled := True;
      Caption := Format('Key count: %d', [NSKeys]);
    end;
    with MSKFlagsLabel do
    begin
      Enabled := True;
      ShowHint := True;
      Caption := Format('Flag: $%x', [NSFlag]);
      Hint := ConvertLoopControlFlags(NSFlag);
    end;
    with MSKListBox do
    begin
      Clear;
      MaxWidth := ClientWidth;
      for I := 0 to NSKeys - 1 do
      begin
        S := ConvertKeyHeader(SKeys[I]) + ConvertPoint(Scale[I]);
        Items.Add(S);
        CurrentWidth := Canvas.TextWidth(S);
        if CurrentWidth > MaxWidth then MaxWidth := CurrentWidth;
      end;
      if MaxWidth > ClientWidth then Inc(MaxWidth, 20);
      SendMessage(Handle, LB_SETHORIZONTALEXTENT, MaxWidth, 0);
    end;

    // morphing keys
    with MMKCountLabel do
    begin
      Enabled := True;
      Caption := Format('Key count: %d', [NMKeys]);
    end;
    with MMKFlagsLabel do
    begin
      Enabled := True;
      ShowHint := True;
      Caption := Format('Flag: $%x', [NMFlag]);
      Hint := ConvertLoopControlFlags(NMFlag);
    end;
    with MMKListBox do
    begin
      Clear;
      MaxWidth := ClientWidth;
      for I := 0 to NMKeys - 1 do
      begin
        S := ConvertKeyHeader(MKeys[I]) + 'target morph object: ' + Morph[I];
        Items.Add(S);
        CurrentWidth := Canvas.TextWidth(S);
        if CurrentWidth > MaxWidth then MaxWidth := CurrentWidth;
      end;
      if MaxWidth > ClientWidth then Inc(MaxWidth, 20);
      SendMessage(Handle, LB_SETHORIZONTALEXTENT, MaxWidth, 0);
    end;

    // hide keys
    with MHKCountLabel do
    begin
      Enabled := True;
      Caption := Format('Key count: %d', [NHKeys]);
    end;
    with MHKFlagsLabel do
    begin
      Enabled := True;
      ShowHint := True;
      Caption := Format('Flag: $%x', [NHFlag]);
      Hint := ConvertLoopControlFlags(NHFlag);
    end;
    with MHKListBox do
    begin
      Clear;
      MaxWidth := ClientWidth;
      for I := 0 to NHKeys - 1 do
      begin
        S := ConvertKeyHeader(HKeys[I]);
        Items.Add(S);
        CurrentWidth := Canvas.TextWidth(S);
        if CurrentWidth > MaxWidth then MaxWidth := CurrentWidth;
      end;
      if MaxWidth > ClientWidth then Inc(MaxWidth, 20);
      SendMessage(Handle, LB_SETHORIZONTALEXTENT, MaxWidth, 0);
    end;
    {$ifdef RangeCheck} {$undef RangeCheck} {$R+} {$endif}
  end;
end;

//---------------------------------------------------------------------------------------------------------------------

procedure TMainForm.OmniMotionListBoxClick(Sender: TObject);

var S: String;
    I: Integer;
    CurrentWidth,
    MaxWidth: Integer;

begin
  with FReader.Keyframer.OmniLightMotion[OmniMotionListBox.ItemIndex]^ do
  begin
    with OParentLabel do
    begin
      Enabled := True;
    end;
    if Parent = '' then OParentLabel.Caption := 'Parent object: none'
                   else OParentLabel.Caption := 'Parent object: ' + Parent;
    with OFlags1Label do
    begin
      Enabled := True;
      Caption := Format('Node flags 1: $%x', [Flags1]);
      ShowHint := True;
      Hint := ConvertHeaderFlags1(Flags1);
    end;
    with OFlags2Label do
    begin
      Enabled := True;
      Caption := Format('Node flags 2: $%x', [Flags2]);
      ShowHint := True;
      Hint := ConvertHeaderFlags1(Flags2);
    end;

    {$ifopt R+} {$R-} {$define RangeCheck} {$endif}
    // position keys
    with OPKCountLabel do
    begin
      Enabled := True;
      Caption := Format('Key count: %d', [NPKeys]);
    end;
    with OPKFlagsLabel do
    begin
      Enabled := True;
      ShowHint := True;
      Caption := Format('Flag: $%x', [NPFlag]);
      Hint := ConvertLoopControlFlags(NPFlag);
    end;
    with OPKListBox do
    begin
      Clear;
      MaxWidth := ClientWidth;
      for I := 0 to NPKeys - 1 do
      begin
        S := ConvertKeyHeader(PKeys[I]) + ConvertPoint(Pos[I]);
        Items.Add(S);
        CurrentWidth := Canvas.TextWidth(S);
        if CurrentWidth > MaxWidth then MaxWidth := CurrentWidth;
      end;
      // make the listbox also scrolling horizontally if necessary
      if MaxWidth > ClientWidth then Inc(MaxWidth, 20);
      SendMessage(Handle, LB_SETHORIZONTALEXTENT, MaxWidth, 0);
    end;
    
    // color keys
    with OCKCountLabel do
    begin
      Enabled := True;
      Caption := Format('Key count: %d', [NCKeys]);
    end;
    with OCKFlagsLabel do
    begin
      Enabled := True;
      ShowHint := True;
      Caption := Format('Flag: $%x', [NCFlag]);
      Hint := ConvertLoopControlFlags(NCFlag);
    end;
    // can't use "with" statement here because it would override the Color array of the omnilight motion 
    OCKListBox.Clear;
    MaxWidth := OCKListBox.ClientWidth;
    for I := 0 to NCKeys - 1 do
    begin
      S := ConvertKeyHeader(CKeys[I]) + ConvertColor(Color[I]);
      OCKListBox.Items.Add(S);
      CurrentWidth := Canvas.TextWidth(S);
      if CurrentWidth > MaxWidth then MaxWidth := CurrentWidth;
    end;
    if MaxWidth > ClientWidth then Inc(MaxWidth, 20);
    SendMessage(OCKListBox.Handle, LB_SETHORIZONTALEXTENT, MaxWidth, 0);

    {$ifdef RangeCheck} {$undef RangeCheck} {$R+} {$endif}
  end;
end;

//---------------------------------------------------------------------------------------------------------------------

procedure TMainForm.SpotMotionListBoxClick(Sender: TObject);

var S: String;
    I: Integer;
    CurrentWidth,
    MaxWidth: Integer;

begin
  with FReader.Keyframer.SpotLightMotion[SpotMotionListBox.ItemIndex]^ do
  begin
    with SParentLabel do
    begin
      Enabled := True;
    end;
    if Parent = '' then SParentLabel.Caption := 'Parent object: none'
                   else SParentLabel.Caption := 'Parent object: ' + Parent;
    with SFlags1Label do
    begin
      Enabled := True;
      Caption := Format('Node flags 1: $%x', [Flags1]);
      ShowHint := True;
      Hint := ConvertHeaderFlags1(Flags1);
    end;
    with SFlags2Label do
    begin
      Enabled := True;
      Caption := Format('Node flags 2: $%x', [Flags2]);
      ShowHint := True;
      Hint := ConvertHeaderFlags1(Flags2);
    end;

    {$ifopt R+} {$R-} {$define RangeCheck} {$endif}
    // position keys
    with SPKCountLabel do
    begin
      Enabled := True;
      Caption := Format('Key count: %d', [NPKeys]);
    end;
    with SPKFlagsLabel do
    begin
      Enabled := True;
      ShowHint := True;
      Caption := Format('Flag: $%x', [NPFlag]);
      Hint := ConvertLoopControlFlags(NPFlag);
    end;
    with SPKListBox do
    begin
      Clear;
      MaxWidth := ClientWidth;
      for I := 0 to NPKeys - 1 do
      begin
        S := ConvertKeyHeader(PKeys[I]) + ConvertPoint(Pos[I]);
        Items.Add(S);
        CurrentWidth := Canvas.TextWidth(S);
        if CurrentWidth > MaxWidth then MaxWidth := CurrentWidth;
      end;
      // make the listbox also scrolling horizontally if necessary
      if MaxWidth > ClientWidth then Inc(MaxWidth, 20);
      SendMessage(Handle, LB_SETHORIZONTALEXTENT, MaxWidth, 0);
    end;

    // color keys
    with SCKCountLabel do
    begin
      Enabled := True;
      Caption := Format('Key count: %d', [NCKeys]);
    end;
    with SCKFlagsLabel do
    begin
      Enabled := True;
      ShowHint := True;
      Caption := Format('Flag: $%x', [NCFlag]);
      Hint := ConvertLoopControlFlags(NCFlag);
    end;
    // can't use "with" statement here because it would override the Color array of the spotlight motion
    SCKListBox.Clear;
    MaxWidth := SCKListBox.ClientWidth;
    for I := 0 to NCKeys - 1 do
    begin
      S := ConvertKeyHeader(CKeys[I]) + ConvertColor(Color[I]);
      SCKListBox.Items.Add(S);
      CurrentWidth := Canvas.TextWidth(S);
      if CurrentWidth > MaxWidth then MaxWidth := CurrentWidth;
    end;
    if MaxWidth > ClientWidth then Inc(MaxWidth, 20);
    SendMessage(SCKListBox.Handle, LB_SETHORIZONTALEXTENT, MaxWidth, 0);

    // hotspot angle keys
    with SHKCountLabel do
    begin
      Enabled := True;
      Caption := Format('Key count: %d', [NHKeys]);
    end;
    with SHKFlagsLabel do
    begin
      Enabled := True;
      ShowHint := True;
      Caption := Format('Flag: $%x', [NHFlag]);
      Hint := ConvertLoopControlFlags(NHFlag);
    end;
    with SHKListBox do
    begin
      Clear;
      MaxWidth := ClientWidth;
      for I := 0 to NHKeys - 1 do
      begin
        S := ConvertKeyHeader(HKeys[I]) + Format('angle: %.3g', [Hot[I]]);
        Items.Add(S);
        CurrentWidth := Canvas.TextWidth(S);
        if CurrentWidth > MaxWidth then MaxWidth := CurrentWidth;
      end;
      if MaxWidth > ClientWidth then Inc(MaxWidth, 20);
      SendMessage(Handle, LB_SETHORIZONTALEXTENT, MaxWidth, 0);
    end;

    // fall off angle keys
    with SFKCountLabel do
    begin
      Enabled := True;
      Caption := Format('Key count: %d', [NFKeys]);
    end;
    with SFKFlagsLabel do
    begin
      Enabled := True;
      ShowHint := True;
      Caption := Format('Flag: $%x', [NFFlag]);
      Hint := ConvertLoopControlFlags(NFFlag);
    end;
    with SFKListBox do
    begin
      Clear;
      MaxWidth := ClientWidth;
      for I := 0 to NFKeys - 1 do
      begin
        S := ConvertKeyHeader(FKeys[I]) + Format('angle: %.3g', [Fall[I]]);
        Items.Add(S);
        CurrentWidth := Canvas.TextWidth(S);
        if CurrentWidth > MaxWidth then MaxWidth := CurrentWidth;
      end;
      if MaxWidth > ClientWidth then Inc(MaxWidth, 20);
      SendMessage(Handle, LB_SETHORIZONTALEXTENT, MaxWidth, 0);
    end;

    // roll keys
    with SRKCountLabel do
    begin
      Enabled := True;
      Caption := Format('Key count: %d', [NRKeys]);
    end;
    with SRKFlagsLabel do
    begin
      Enabled := True;
      ShowHint := True;
      Caption := Format('Flag: $%x', [NRFlag]);
      Hint := ConvertLoopControlFlags(NRFlag);
    end;
    with SRKListBox do
    begin
      Clear;
      MaxWidth := ClientWidth;
      for I := 0 to NRKeys - 1 do
      begin
        S := ConvertKeyHeader(RKeys[I]) + Format('angle: %.3g', [Roll[I]]);
        Items.Add(S);
        CurrentWidth := Canvas.TextWidth(S);
        if CurrentWidth > MaxWidth then MaxWidth := CurrentWidth;
      end;
      if MaxWidth > ClientWidth then Inc(MaxWidth, 20);
      SendMessage(Handle, LB_SETHORIZONTALEXTENT, MaxWidth, 0);
    end;

    // parent position keys
    with STKCountLabel do
    begin
      Enabled := True;
      Caption := Format('Key count: %d', [NPKeys]);
    end;
    with STKFlagsLabel do
    begin
      Enabled := True;
      ShowHint := True;
      Caption := Format('Flag: $%x', [NPFlag]);
      Hint := ConvertLoopControlFlags(NPFlag);
    end;
    with STKParentLabel do
    begin
      Enabled := True;
      if TParent <> '' then Caption := 'Target parent: ' + TParent
                       else Caption := 'Target parent: none';
    end;
    // Note: target parent's node header flags aren't shown here. They can be gotten from the
    //       particular target's general info.
    with STKListBox do
    begin
      Clear;
      MaxWidth := ClientWidth;
      for I := 0 to NTKeys - 1 do
      begin
        S := ConvertKeyHeader(TKeys[I]) + ConvertPoint(TPos[I]);
        Items.Add(S);
        CurrentWidth := Canvas.TextWidth(S);
        if CurrentWidth > MaxWidth then MaxWidth := CurrentWidth;
      end;
      if MaxWidth > ClientWidth then Inc(MaxWidth, 20);
      SendMessage(Handle, LB_SETHORIZONTALEXTENT, MaxWidth, 0);
    end;

    {$ifdef RangeCheck} {$undef RangeCheck} {$R+} {$endif}
  end;
end;

//---------------------------------------------------------------------------------------------------------------------

procedure TMainForm.CameraMotionListBoxClick(Sender: TObject);

var S: String;
    I: Integer;
    CurrentWidth,
    MaxWidth: Integer;

begin
  with FReader.Keyframer.CameraMotion[CameraMotionListBox.ItemIndex]^ do
  begin
    with CParentLabel do
    begin
      Enabled := True;
    end;
    if Parent = '' then CParentLabel.Caption := 'Parent object: none'
                   else CParentLabel.Caption := 'Parent object: ' + Parent;
    with CFlags1Label do
    begin
      Enabled := True;
      Caption := Format('Node flags 1: $%x', [Flags1]);
      ShowHint := True;
      Hint := ConvertHeaderFlags1(Flags1);
    end;
    with CFlags2Label do
    begin
      Enabled := True;
      Caption := Format('Node flags 2: $%x', [Flags2]);
      ShowHint := True;
      Hint := ConvertHeaderFlags1(Flags2);
    end;

    {$ifopt R+} {$R-} {$define RangeCheck} {$endif}
    // position keys
    with CPKCountLabel do
    begin
      Enabled := True;
      Caption := Format('Key count: %d', [NPKeys]);
    end;
    with CPKFlagsLabel do
    begin
      Enabled := True;
      ShowHint := True;
      Caption := Format('Flag: $%x', [NPFlag]);
      Hint := ConvertLoopControlFlags(NPFlag);
    end;
    with CPKListBox do
    begin
      Clear;
      MaxWidth := ClientWidth;
      for I := 0 to NPKeys - 1 do
      begin
        S := ConvertKeyHeader(PKeys[I]) + ConvertPoint(Pos[I]);
        Items.Add(S);
        CurrentWidth := Canvas.TextWidth(S);
        if CurrentWidth > MaxWidth then MaxWidth := CurrentWidth;
      end;
      // make the listbox also scrolling horizontally if necessary
      if MaxWidth > ClientWidth then Inc(MaxWidth, 20);
      SendMessage(Handle, LB_SETHORIZONTALEXTENT, MaxWidth, 0);
    end;

    // field of view (FOV) angle keys
    with CFKCountLabel do
    begin
      Enabled := True;
      Caption := Format('Key count: %d', [NFKeys]);
    end;
    with CFKFlagsLabel do
    begin
      Enabled := True;
      ShowHint := True;
      Caption := Format('Flag: $%x', [NFFlag]);
      Hint := ConvertLoopControlFlags(NFFlag);
    end;
    with CFKListBox do
    begin
      Clear;
      MaxWidth := ClientWidth;
      for I := 0 to NFKeys - 1 do
      begin
        S := ConvertKeyHeader(FKeys[I]) + Format('angle: %.3g', [FOV[I]]);
        Items.Add(S);
        CurrentWidth := Canvas.TextWidth(S);
        if CurrentWidth > MaxWidth then MaxWidth := CurrentWidth;
      end;
      if MaxWidth > ClientWidth then Inc(MaxWidth, 20);
      SendMessage(Handle, LB_SETHORIZONTALEXTENT, MaxWidth, 0);
    end;

    // roll keys
    with CRKCountLabel do
    begin
      Enabled := True;
      Caption := Format('Key count: %d', [NRKeys]);
    end;
    with CRKFlagsLabel do
    begin
      Enabled := True;
      ShowHint := True;
      Caption := Format('Flag: $%x', [NRFlag]);
      Hint := ConvertLoopControlFlags(NRFlag);
    end;
    with CRKListBox do
    begin
      Clear;
      MaxWidth := ClientWidth;
      for I := 0 to NRKeys - 1 do
      begin
        S := ConvertKeyHeader(RKeys[I]) + Format('angle: %.3g', [Roll[I]]);
        Items.Add(S);
        CurrentWidth := Canvas.TextWidth(S);
        if CurrentWidth > MaxWidth then MaxWidth := CurrentWidth;
      end;
      if MaxWidth > ClientWidth then Inc(MaxWidth, 20);
      SendMessage(Handle, LB_SETHORIZONTALEXTENT, MaxWidth, 0);
    end;

    // parent position keys
    with CTKCountLabel do
    begin
      Enabled := True;
      Caption := Format('Key count: %d', [NPKeys]);
    end;
    with CTKFlagsLabel do
    begin
      Enabled := True;
      ShowHint := True;
      Caption := Format('Flag: $%x', [NPFlag]);
      Hint := ConvertLoopControlFlags(NPFlag);
    end;
    with CTKParentLabel do
    begin
      Enabled := True;
      if TParent <> '' then Caption := 'Target parent: ' + TParent
                       else Caption := 'Target parent: none';
    end;
    // Note: target parent's node header flags aren't shown here. They can be gotten from the
    //       particular target's general info.
    with CTKListBox do
    begin
      Clear;
      MaxWidth := ClientWidth;
      for I := 0 to NTKeys - 1 do
      begin
        S := ConvertKeyHeader(TKeys[I]) + ConvertPoint(TPos[I]);
        Items.Add(S);
        CurrentWidth := Canvas.TextWidth(S);
        if CurrentWidth > MaxWidth then MaxWidth := CurrentWidth;
      end;
      if MaxWidth > ClientWidth then Inc(MaxWidth, 20);
      SendMessage(Handle, LB_SETHORIZONTALEXTENT, MaxWidth, 0);
    end;

    {$ifdef RangeCheck} {$undef RangeCheck} {$R+} {$endif}
  end;
end;

//---------------------------------------------------------------------------------------------------------------------

procedure TMainForm.MRUClick(Sender: TObject);

var Index: Integer;

begin
  Index := MRUFilePopup.Items.IndexOf(Sender as TMenuItem);
  DoLoad(FMRUFiles[Index]);
end;

//---------------------------------------------------------------------------------------------------------------------

procedure TMainForm.MRUFilePopupPopup(Sender: TObject);

var I: Integer;

begin
  with MRUFilePopup do
  begin
    while Items.Count > 0 do Items.Delete(0);
    I := 0;
    while I < FMRUFiles.Count do
    begin
      if FileExists(FMRUFiles[I]) then
      begin
        Items.Add(NewItem(FMRUFiles[I], 0, False, True, MRUClick, 0, ''));
        Inc(I);
      end
      else
        FMRUFiles.Delete(I);
    end;
  end;
end;

//---------------------------------------------------------------------------------------------------------------------

procedure TMainForm.WMDropFiles(var Msg: TWMDropFiles);

// the common game here if a file has been dropped on the application

var
  Buffer: array[0..MAX_PATH] of Char;
  Count: Cardinal;

begin
  Count := DragQueryFile(Msg.Drop, DWORD(-1), nil, 0);
  if Count > 0 then
  begin
    DragQueryFile(Msg.Drop, 0, Buffer, MAX_PATH);
    DoLoad(Buffer);
    DragFinish(Msg.Drop);
    Msg.Result := 0;
  end;
end;

//---------------------------------------------------------------------------------------------------------------------

end.

